//  Support for text overlays in NDPluginOverlay
//  Keith Brister 2014-06-26
//
// 6x13
// -Misc-Fixed-Medium-R-SemiCondensed--13-120-75-75-C-60-ISO10646-1
//
// Font from http://www.cl.cam.ac.uk/~mgk25/ucs-fonts.html
//
// This font appears to be in the public domain.
//
// The full font has been whittled down to the characters 32 through 255.  
// When UTF-8, in its full glory, is needed it shouldn't be too difficult to support.
//
// Created from bdf2c Version 3, (c) 2009, 2010 by Lutz Sammer
//    License AGPLv3: GNU Affero General Public License version 3
//

#include "NDPluginOverlayTextFont.h"

/// character bitmap for each encoding
const unsigned char font_6x13[] = {
//  32 $20 'space'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
//  33 $21 'exclam'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    ________,
    __X_____,
    ________,
    ________,
//  34 $22 'quotedbl'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X_X____,
    _X_X____,
    _X_X____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
//  35 $23 'numbersign'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    _X_X____,
    _X_X____,
    XXXXX___,
    _X_X____,
    XXXXX___,
    _X_X____,
    _X_X____,
    ________,
    ________,
    ________,
//  36 $24 'dollar'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_____,
    _XXXX___,
    X_X_____,
    X_X_____,
    _XXX____,
    __X_X___,
    __X_X___,
    XXXX____,
    __X_____,
    ________,
    ________,
//  37 $25 'percent'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X__X___,
    X_X_X___,
    _X_X____,
    ___X____,
    __X_____,
    _X______,
    _X_X____,
    X_X_X___,
    X__X____,
    ________,
    ________,
//  38 $26 'ampersand'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    _X______,
    X_X_____,
    X_X_____,
    _X______,
    X_X_____,
    X__XX___,
    X__X____,
    _XX_X___,
    ________,
    ________,
//  39 $27 'quotesingle'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_____,
    __X_____,
    __X_____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
//  40 $28 'parenleft'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___X____,
    __X_____,
    __X_____,
    _X______,
    _X______,
    _X______,
    _X______,
    _X______,
    __X_____,
    __X_____,
    ___X____,
    ________,
//  41 $29 'parenright'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X______,
    __X_____,
    __X_____,
    ___X____,
    ___X____,
    ___X____,
    ___X____,
    ___X____,
    __X_____,
    __X_____,
    _X______,
    ________,
//  42 $2a 'asterisk'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_____,
    X_X_X___,
    _XXX____,
    X_X_X___,
    __X_____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
//  43 $2b 'plus'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    __X_____,
    __X_____,
    XXXXX___,
    __X_____,
    __X_____,
    ________,
    ________,
    ________,
    ________,
//  44 $2c 'comma'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    __XX____,
    __X_____,
    _X______,
    ________,
//  45 $2d 'hyphen'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    XXXXX___,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
//  46 $2e 'period'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    __X_____,
    _XXX____,
    __X_____,
    ________,
//  47 $2f 'slash'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ____X___,
    ____X___,
    ___X____,
    ___X____,
    __X_____,
    _X______,
    _X______,
    X_______,
    X_______,
    ________,
    ________,
//  48 $30 'zero'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_____,
    _X_X____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _X_X____,
    __X_____,
    ________,
    ________,
//  49 $31 'one'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_____,
    _XX_____,
    X_X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    XXXXX___,
    ________,
    ________,
//  50 $32 'two'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    ____X___,
    ___X____,
    __X_____,
    _X______,
    X_______,
    XXXXX___,
    ________,
    ________,
//  51 $33 'three'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    ____X___,
    ___X____,
    __X_____,
    _XXX____,
    ____X___,
    ____X___,
    X___X___,
    _XXX____,
    ________,
    ________,
//  52 $34 'four'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___X____,
    ___X____,
    __XX____,
    _X_X____,
    _X_X____,
    X__X____,
    XXXXX___,
    ___X____,
    ___X____,
    ________,
    ________,
//  53 $35 'five'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    X_______,
    X_______,
    X_XX____,
    XX__X___,
    ____X___,
    ____X___,
    X___X___,
    _XXX____,
    ________,
    ________,
//  54 $36 'six'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    X___X___,
    X_______,
    X_______,
    XXXX____,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
//  55 $37 'seven'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    ____X___,
    ___X____,
    ___X____,
    __X_____,
    __X_____,
    _X______,
    _X______,
    _X______,
    ________,
    ________,
//  56 $38 'eight'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
//  57 $39 'nine'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    _XXXX___,
    ____X___,
    ____X___,
    X___X___,
    _XXX____,
    ________,
    ________,
//  58 $3a 'colon'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    __X_____,
    _XXX____,
    __X_____,
    ________,
    ________,
    __X_____,
    _XXX____,
    __X_____,
    ________,
//  59 $3b 'semicolon'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    __X_____,
    _XXX____,
    __X_____,
    ________,
    ________,
    __XX____,
    __X_____,
    _X______,
    ________,
//  60 $3c 'less'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ____X___,
    ___X____,
    __X_____,
    _X______,
    X_______,
    _X______,
    __X_____,
    ___X____,
    ____X___,
    ________,
    ________,
//  61 $3d 'equal'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XXXXX___,
    ________,
    ________,
    XXXXX___,
    ________,
    ________,
    ________,
    ________,
//  62 $3e 'greater'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X_______,
    _X______,
    __X_____,
    ___X____,
    ____X___,
    ___X____,
    __X_____,
    _X______,
    X_______,
    ________,
    ________,
//  63 $3f 'question'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    ____X___,
    ___X____,
    __X_____,
    __X_____,
    ________,
    __X_____,
    ________,
    ________,
//  64 $40 'at'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X__XX___,
    X_X_X___,
    X_X_X___,
    X_XX____,
    X_______,
    _XXXX___,
    ________,
    ________,
//  65 $41 'A'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_____,
    _X_X____,
    X___X___,
    X___X___,
    X___X___,
    XXXXX___,
    X___X___,
    X___X___,
    X___X___,
    ________,
    ________,
//  66 $42 'B'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXX____,
    _X__X___,
    _X__X___,
    _X__X___,
    _XXX____,
    _X__X___,
    _X__X___,
    _X__X___,
    XXXX____,
    ________,
    ________,
//  67 $43 'C'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    X___X___,
    X_______,
    X_______,
    X_______,
    X_______,
    X_______,
    X___X___,
    _XXX____,
    ________,
    ________,
//  68 $44 'D'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXX____,
    _X__X___,
    _X__X___,
    _X__X___,
    _X__X___,
    _X__X___,
    _X__X___,
    _X__X___,
    XXXX____,
    ________,
    ________,
//  69 $45 'E'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    X_______,
    X_______,
    X_______,
    XXXX____,
    X_______,
    X_______,
    X_______,
    XXXXX___,
    ________,
    ________,
//  70 $46 'F'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    X_______,
    X_______,
    X_______,
    XXXX____,
    X_______,
    X_______,
    X_______,
    X_______,
    ________,
    ________,
//  71 $47 'G'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    X___X___,
    X_______,
    X_______,
    X_______,
    X__XX___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
//  72 $48 'H'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    XXXXX___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    ________,
    ________,
//  73 $49 'I'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    _XXX____,
    ________,
    ________,
//  74 $4a 'J'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XXX___,
    ___X____,
    ___X____,
    ___X____,
    ___X____,
    ___X____,
    ___X____,
    X__X____,
    _XX_____,
    ________,
    ________,
//  75 $4b 'K'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X___X___,
    X___X___,
    X__X____,
    X_X_____,
    XX______,
    X_X_____,
    X__X____,
    X___X___,
    X___X___,
    ________,
    ________,
//  76 $4c 'L'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X_______,
    X_______,
    X_______,
    X_______,
    X_______,
    X_______,
    X_______,
    X_______,
    XXXXX___,
    ________,
    ________,
//  77 $4d 'M'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X___X___,
    X___X___,
    XX_XX___,
    X_X_X___,
    X_X_X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    ________,
    ________,
//  78 $4e 'N'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X___X___,
    XX__X___,
    XX__X___,
    X_X_X___,
    X_X_X___,
    X__XX___,
    X__XX___,
    X___X___,
    X___X___,
    ________,
    ________,
//  79 $4f 'O'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
//  80 $50 'P'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXX____,
    X___X___,
    X___X___,
    X___X___,
    XXXX____,
    X_______,
    X_______,
    X_______,
    X_______,
    ________,
    ________,
//  81 $51 'Q'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X_X_X___,
    _XXX____,
    ____X___,
    ________,
//  82 $52 'R'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXX____,
    X___X___,
    X___X___,
    X___X___,
    XXXX____,
    X_X_____,
    X__X____,
    X___X___,
    X___X___,
    ________,
    ________,
//  83 $53 'S'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    X___X___,
    X_______,
    X_______,
    _XXX____,
    ____X___,
    ____X___,
    X___X___,
    _XXX____,
    ________,
    ________,
//  84 $54 'T'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    ________,
    ________,
//  85 $55 'U'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
//  86 $56 'V'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _X_X____,
    _X_X____,
    _X_X____,
    __X_____,
    __X_____,
    ________,
    ________,
//  87 $57 'W'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X_X_X___,
    X_X_X___,
    X_X_X___,
    X_X_X___,
    _X_X____,
    ________,
    ________,
//  88 $58 'X'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X___X___,
    X___X___,
    _X_X____,
    _X_X____,
    __X_____,
    _X_X____,
    _X_X____,
    X___X___,
    X___X___,
    ________,
    ________,
//  89 $59 'Y'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X___X___,
    X___X___,
    _X_X____,
    _X_X____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    ________,
    ________,
//  90 $5a 'Z'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    ____X___,
    ___X____,
    ___X____,
    __X_____,
    _X______,
    _X______,
    X_______,
    XXXXX___,
    ________,
    ________,
//  91 $5b 'bracketleft'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XXX____,
    _X______,
    _X______,
    _X______,
    _X______,
    _X______,
    _X______,
    _X______,
    _X______,
    _X______,
    _XXX____,
    ________,
//  92 $5c 'backslash'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X_______,
    X_______,
    _X______,
    _X______,
    __X_____,
    ___X____,
    ___X____,
    ____X___,
    ____X___,
    ________,
    ________,
//  93 $5d 'bracketright'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XXX____,
    ___X____,
    ___X____,
    ___X____,
    ___X____,
    ___X____,
    ___X____,
    ___X____,
    ___X____,
    ___X____,
    _XXX____,
    ________,
//  94 $5e 'asciicircum'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_____,
    _X_X____,
    X___X___,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
//  95 $5f 'underscore'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    XXXXX___,
    ________,
//  96 $60 'grave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __X_____,
    ___X____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
//  97 $61 'a'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXX____,
    ____X___,
    _XXXX___,
    X___X___,
    X__XX___,
    _XX_X___,
    ________,
    ________,
//  98 $62 'b'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X_______,
    X_______,
    X_______,
    XXXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    XXXX____,
    ________,
    ________,
//  99 $63 'c'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXX____,
    X___X___,
    X_______,
    X_______,
    X___X___,
    _XXX____,
    ________,
    ________,
// 100 $64 'd'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ____X___,
    ____X___,
    ____X___,
    _XXXX___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXXX___,
    ________,
    ________,
// 101 $65 'e'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXX____,
    X___X___,
    XXXXX___,
    X_______,
    X___X___,
    _XXX____,
    ________,
    ________,
// 102 $66 'f'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    _X__X___,
    _X______,
    _X______,
    XXXX____,
    _X______,
    _X______,
    _X______,
    _X______,
    ________,
    ________,
// 103 $67 'g'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    _XXXX___,
    ____X___,
    X___X___,
    _XXX____,
// 104 $68 'h'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X_______,
    X_______,
    X_______,
    X_XX____,
    XX__X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    ________,
    ________,
// 105 $69 'i'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    __X_____,
    ________,
    _XX_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    _XXX____,
    ________,
    ________,
// 106 $6a 'j'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ___X____,
    ________,
    __XX____,
    ___X____,
    ___X____,
    ___X____,
    ___X____,
    X__X____,
    X__X____,
    _XX_____,
// 107 $6b 'k'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X_______,
    X_______,
    X_______,
    X__X____,
    X_X_____,
    XX______,
    X_X_____,
    X__X____,
    X___X___,
    ________,
    ________,
// 108 $6c 'l'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XX_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    _XXX____,
    ________,
    ________,
// 109 $6d 'm'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XX_X____,
    X_X_X___,
    X_X_X___,
    X_X_X___,
    X_X_X___,
    X___X___,
    ________,
    ________,
// 110 $6e 'n'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    X_XX____,
    XX__X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    ________,
    ________,
// 111 $6f 'o'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 112 $70 'p'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XXXX____,
    X___X___,
    X___X___,
    X___X___,
    XXXX____,
    X_______,
    X_______,
    X_______,
// 113 $71 'q'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXXX___,
    X___X___,
    X___X___,
    X___X___,
    _XXXX___,
    ____X___,
    ____X___,
    ____X___,
// 114 $72 'r'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    X_XX____,
    XX__X___,
    X_______,
    X_______,
    X_______,
    X_______,
    ________,
    ________,
// 115 $73 's'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXX____,
    X___X___,
    _XX_____,
    ___X____,
    X___X___,
    _XXX____,
    ________,
    ________,
// 116 $74 't'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    _X______,
    _X______,
    XXXX____,
    _X______,
    _X______,
    _X______,
    _X__X___,
    __XX____,
    ________,
    ________,
// 117 $75 'u'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X__XX___,
    _XX_X___,
    ________,
    ________,
// 118 $76 'v'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    X___X___,
    X___X___,
    X___X___,
    _X_X____,
    _X_X____,
    __X_____,
    ________,
    ________,
// 119 $77 'w'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    X___X___,
    X___X___,
    X_X_X___,
    X_X_X___,
    X_X_X___,
    _X_X____,
    ________,
    ________,
// 120 $78 'x'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    X___X___,
    _X_X____,
    __X_____,
    __X_____,
    _X_X____,
    X___X___,
    ________,
    ________,
// 121 $79 'y'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X__XX___,
    _XX_X___,
    ____X___,
    X___X___,
    _XXX____,
// 122 $7a 'z'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XXXXX___,
    ___X____,
    __X_____,
    _X______,
    X_______,
    XXXXX___,
    ________,
    ________,
// 123 $7b 'braceleft'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___XX___,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    XX______,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    ___XX___,
    ________,
// 124 $7c 'bar'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    ________,
    ________,
// 125 $7d 'braceright'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    XX______,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    ___XX___,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    XX______,
    ________,
// 126 $7e 'asciitilde'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X__X___,
    X_X_X___,
    X__X____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 160 $a0 'space'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 161 $a1 'exclamdown'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_____,
    ________,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    ________,
    ________,
// 162 $a2 'cent'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_____,
    _XXX____,
    X_X_X___,
    X_X_____,
    X_X_____,
    X_X_X___,
    _XXX____,
    __X_____,
    ________,
    ________,
    ________,
// 163 $a3 'sterling'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    _X__X___,
    _X______,
    _X______,
    XXX_____,
    _X______,
    _X______,
    _X__X___,
    X_XX____,
    ________,
    ________,
// 164 $a4 'currency'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    X___X___,
    _XXX____,
    _X_X____,
    _X_X____,
    _XXX____,
    X___X___,
    ________,
    ________,
    ________,
// 165 $a5 'yen'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X___X___,
    X___X___,
    _X_X____,
    _X_X____,
    XXXXX___,
    __X_____,
    XXXXX___,
    __X_____,
    __X_____,
    ________,
    ________,
// 166 $a6 'brokenbar'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    ________,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    ________,
    ________,
// 167 $a7 'section'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX____,
    _X__X___,
    _X______,
    __XX____,
    _X__X___,
    _X__X___,
    __XX____,
    ____X___,
    _X__X___,
    __XX____,
    ________,
    ________,
// 168 $a8 'dieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X_X____,
    _X_X____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 169 $a9 'copyright'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XXX____,
    X___X___,
    X_X_X___,
    XX_XX___,
    XX__X___,
    XX_XX___,
    X_X_X___,
    X___X___,
    _XXX____,
    ________,
    ________,
    ________,
// 170 $aa 'ordfeminine'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    ____X___,
    _XXXX___,
    X___X___,
    _XXXX___,
    ________,
    XXXXX___,
    ________,
    ________,
    ________,
    ________,
// 171 $ab 'guillemotleft'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    __X_X___,
    _X_X____,
    X_X_____,
    X_X_____,
    _X_X____,
    __X_X___,
    ________,
    ________,
    ________,
// 172 $ac 'logicalnot'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    XXXXX___,
    ____X___,
    ____X___,
    ________,
    ________,
    ________,
    ________,
// 173 $ad 'hyphen'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXX____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 174 $ae 'registered'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XXX____,
    X___X___,
    XXX_X___,
    XX_XX___,
    XX_XX___,
    XXX_X___,
    XX_XX___,
    X___X___,
    _XXX____,
    ________,
    ________,
    ________,
// 175 $af 'macron'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 176 $b0 'degree'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    _X__X___,
    _X__X___,
    __XX____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 177 $b1 'plusminus'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    __X_____,
    __X_____,
    XXXXX___,
    __X_____,
    __X_____,
    ________,
    XXXXX___,
    ________,
    ________,
    ________,
// 178 $b2 'twosuperior'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X______,
    X_X_____,
    __X_____,
    _X______,
    XXX_____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 179 $b3 'threesuperior'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X______,
    X_X_____,
    _X______,
    __X_____,
    XX______,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 180 $b4 'acute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___X____,
    __X_____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 181 $b5 'mu'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X__XX___,
    XXX_X___,
    X_______,
    X_______,
// 182 $b6 'paragraph'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XXX_X___,
    XXX_X___,
    XXX_X___,
    XXX_X___,
    _XX_X___,
    __X_X___,
    __X_X___,
    __X_X___,
    ________,
    ________,
// 183 $b7 'periodcentered'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    __XX____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 184 $b8 'cedilla'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ___X____,
    __X_____,
// 185 $b9 'onesuperior'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X______,
    XX______,
    _X______,
    _X______,
    XXX_____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 186 $ba 'ordmasculine'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    XXXXX___,
    ________,
    ________,
    ________,
    ________,
// 187 $bb 'guillemotright'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    X_X_____,
    _X_X____,
    __X_X___,
    __X_X___,
    _X_X____,
    X_X_____,
    ________,
    ________,
    ________,
// 188 $bc 'onequarter'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X______,
    XX______,
    _X______,
    _X______,
    XXX_____,
    ____X___,
    ___XX___,
    __X_X___,
    __XXX___,
    ____X___,
    ________,
    ________,
// 189 $bd 'onehalf'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X______,
    XX______,
    _X______,
    _X______,
    XXX_____,
    ___X____,
    __X_X___,
    ____X___,
    ___X____,
    __XXX___,
    ________,
    ________,
// 190 $be 'threequarters'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X______,
    X_X_____,
    _X______,
    __X_____,
    X_X_____,
    _X__X___,
    ___XX___,
    __X_X___,
    __XXX___,
    ____X___,
    ________,
    ________,
// 191 $bf 'questiondown'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_____,
    ________,
    __X_____,
    __X_____,
    _X______,
    X_______,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 192 $c0 'Agrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X______,
    __X_____,
    ________,
    __X_____,
    _X_X____,
    X___X___,
    X___X___,
    XXXXX___,
    X___X___,
    X___X___,
    ________,
    ________,
// 193 $c1 'Aacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___X____,
    __X_____,
    ________,
    __X_____,
    _X_X____,
    X___X___,
    X___X___,
    XXXXX___,
    X___X___,
    X___X___,
    ________,
    ________,
// 194 $c2 'Acircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX____,
    _X__X___,
    ________,
    __X_____,
    _X_X____,
    X___X___,
    X___X___,
    XXXXX___,
    X___X___,
    X___X___,
    ________,
    ________,
// 195 $c3 'Atilde'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __X_X___,
    _X_X____,
    ________,
    __X_____,
    _X_X____,
    X___X___,
    X___X___,
    XXXXX___,
    X___X___,
    X___X___,
    ________,
    ________,
// 196 $c4 'Adieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X_X____,
    _X_X____,
    ________,
    __X_____,
    _X_X____,
    X___X___,
    X___X___,
    XXXXX___,
    X___X___,
    X___X___,
    ________,
    ________,
// 197 $c5 'Aring'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __X_____,
    _X_X____,
    __X_____,
    __X_____,
    _X_X____,
    X___X___,
    X___X___,
    XXXXX___,
    X___X___,
    X___X___,
    ________,
    ________,
// 198 $c6 'AE'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X_XX___,
    X_X_____,
    X_X_____,
    X_X_____,
    X_XX____,
    XXX_____,
    X_X_____,
    X_X_____,
    X_XXX___,
    ________,
    ________,
// 199 $c7 'Ccedilla'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    X___X___,
    X_______,
    X_______,
    X_______,
    X_______,
    X_______,
    X___X___,
    _XXX____,
    __X_____,
    _X______,
// 200 $c8 'Egrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X______,
    __X_____,
    ________,
    XXXXX___,
    X_______,
    X_______,
    XXXX____,
    X_______,
    X_______,
    XXXXX___,
    ________,
    ________,
// 201 $c9 'Eacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___X____,
    __X_____,
    ________,
    XXXXX___,
    X_______,
    X_______,
    XXXX____,
    X_______,
    X_______,
    XXXXX___,
    ________,
    ________,
// 202 $ca 'Ecircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX____,
    _X__X___,
    ________,
    XXXXX___,
    X_______,
    X_______,
    XXXX____,
    X_______,
    X_______,
    XXXXX___,
    ________,
    ________,
// 203 $cb 'Edieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X_X____,
    _X_X____,
    ________,
    XXXXX___,
    X_______,
    X_______,
    XXXX____,
    X_______,
    X_______,
    XXXXX___,
    ________,
    ________,
// 204 $cc 'Igrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X______,
    __X_____,
    ________,
    _XXX____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    _XXX____,
    ________,
    ________,
// 205 $cd 'Iacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___X____,
    __X_____,
    ________,
    _XXX____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    _XXX____,
    ________,
    ________,
// 206 $ce 'Icircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX____,
    _X__X___,
    ________,
    _XXX____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    _XXX____,
    ________,
    ________,
// 207 $cf 'Idieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X_X____,
    _X_X____,
    ________,
    _XXX____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    _XXX____,
    ________,
    ________,
// 208 $d0 'Eth'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXX____,
    _X__X___,
    _X__X___,
    _X__X___,
    XXX_X___,
    _X__X___,
    _X__X___,
    _X__X___,
    XXXX____,
    ________,
    ________,
// 209 $d1 'Ntilde'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __X_X___,
    _X_X____,
    ________,
    X___X___,
    X___X___,
    XX__X___,
    X_X_X___,
    X__XX___,
    X___X___,
    X___X___,
    ________,
    ________,
// 210 $d2 'Ograve'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X______,
    __X_____,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 211 $d3 'Oacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___X____,
    __X_____,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 212 $d4 'Ocircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX____,
    _X__X___,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 213 $d5 'Otilde'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __X_X___,
    _X_X____,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 214 $d6 'Odieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X_X____,
    _X_X____,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 215 $d7 'multiply'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    X___X___,
    _X_X____,
    __X_____,
    _X_X____,
    X___X___,
    ________,
    ________,
    ________,
// 216 $d8 'Oslash'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ____X___,
    _XXX____,
    X__XX___,
    X__XX___,
    X_X_X___,
    X_X_X___,
    X_X_X___,
    XX__X___,
    XX__X___,
    _XXX____,
    X_______,
    ________,
// 217 $d9 'Ugrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X______,
    __X_____,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 218 $da 'Uacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___X____,
    __X_____,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 219 $db 'Ucircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX____,
    _X__X___,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 220 $dc 'Udieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X_X____,
    _X_X____,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 221 $dd 'Yacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___X____,
    __X_____,
    ________,
    X___X___,
    X___X___,
    _X_X____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    ________,
    ________,
// 222 $de 'Thorn'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    X_______,
    XXXX____,
    X___X___,
    X___X___,
    X___X___,
    XXXX____,
    X_______,
    X_______,
    X_______,
    ________,
    ________,
// 223 $df 'germandbls'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XX_____,
    X__X____,
    X__X____,
    X_X_____,
    X_X_____,
    X__X____,
    X___X___,
    X___X___,
    X_XX____,
    ________,
    ________,
// 224 $e0 'agrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X______,
    __X_____,
    ________,
    _XXX____,
    ____X___,
    _XXXX___,
    X___X___,
    X__XX___,
    _XX_X___,
    ________,
    ________,
// 225 $e1 'aacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___X____,
    __X_____,
    ________,
    _XXX____,
    ____X___,
    _XXXX___,
    X___X___,
    X__XX___,
    _XX_X___,
    ________,
    ________,
// 226 $e2 'acircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    _X__X___,
    ________,
    _XXX____,
    ____X___,
    _XXXX___,
    X___X___,
    X__XX___,
    _XX_X___,
    ________,
    ________,
// 227 $e3 'atilde'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_X___,
    _X_X____,
    ________,
    _XXX____,
    ____X___,
    _XXXX___,
    X___X___,
    X__XX___,
    _XX_X___,
    ________,
    ________,
// 228 $e4 'adieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X_X____,
    _X_X____,
    ________,
    _XXX____,
    ____X___,
    _XXXX___,
    X___X___,
    X__XX___,
    _XX_X___,
    ________,
    ________,
// 229 $e5 'aring'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX____,
    _X__X___,
    __XX____,
    ________,
    _XXX____,
    ____X___,
    _XXXX___,
    X___X___,
    X__XX___,
    _XX_X___,
    ________,
    ________,
// 230 $e6 'ae'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXX____,
    __X_X___,
    _XXX____,
    X_X_____,
    X_X_X___,
    _X_X____,
    ________,
    ________,
// 231 $e7 'ccedilla'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXX____,
    X___X___,
    X_______,
    X_______,
    X___X___,
    _XXX____,
    __X_____,
    _X______,
// 232 $e8 'egrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X______,
    __X_____,
    ________,
    _XXX____,
    X___X___,
    XXXXX___,
    X_______,
    X___X___,
    _XXX____,
    ________,
    ________,
// 233 $e9 'eacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___X____,
    __X_____,
    ________,
    _XXX____,
    X___X___,
    XXXXX___,
    X_______,
    X___X___,
    _XXX____,
    ________,
    ________,
// 234 $ea 'ecircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    _X__X___,
    ________,
    _XXX____,
    X___X___,
    XXXXX___,
    X_______,
    X___X___,
    _XXX____,
    ________,
    ________,
// 235 $eb 'edieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X_X____,
    _X_X____,
    ________,
    _XXX____,
    X___X___,
    XXXXX___,
    X_______,
    X___X___,
    _XXX____,
    ________,
    ________,
// 236 $ec 'igrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X______,
    __X_____,
    ________,
    _XX_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    _XXX____,
    ________,
    ________,
// 237 $ed 'iacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___X____,
    __X_____,
    ________,
    _XX_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    _XXX____,
    ________,
    ________,
// 238 $ee 'icircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    _X__X___,
    ________,
    _XX_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    _XXX____,
    ________,
    ________,
// 239 $ef 'idieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X_X____,
    _X_X____,
    ________,
    _XX_____,
    __X_____,
    __X_____,
    __X_____,
    __X_____,
    _XXX____,
    ________,
    ________,
// 240 $f0 'eth'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _X_X____,
    __X_____,
    _XX_____,
    ___X____,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 241 $f1 'ntilde'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_X___,
    _X_X____,
    ________,
    X_XX____,
    XX__X___,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    ________,
    ________,
// 242 $f2 'ograve'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X______,
    __X_____,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 243 $f3 'oacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___X____,
    __X_____,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 244 $f4 'ocircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    _X__X___,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 245 $f5 'otilde'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __X_X___,
    _X_X____,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 246 $f6 'odieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X_X____,
    _X_X____,
    ________,
    _XXX____,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    _XXX____,
    ________,
    ________,
// 247 $f7 'divide'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    __X_____,
    __X_____,
    ________,
    XXXXX___,
    ________,
    __X_____,
    __X_____,
    ________,
    ________,
    ________,
// 248 $f8 'oslash'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ____X___,
    _XXX____,
    X__XX___,
    X_X_X___,
    X_X_X___,
    XX__X___,
    _XXX____,
    X_______,
    ________,
// 249 $f9 'ugrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X______,
    __X_____,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X__XX___,
    _XX_X___,
    ________,
    ________,
// 250 $fa 'uacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___X____,
    __X_____,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X__XX___,
    _XX_X___,
    ________,
    ________,
// 251 $fb 'ucircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    _X__X___,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X__XX___,
    _XX_X___,
    ________,
    ________,
// 252 $fc 'udieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X_X____,
    _X_X____,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X___X___,
    X__XX___,
    _XX_X___,
    ________,
    ________,
// 253 $fd 'yacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___X____,
    __X_____,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X__XX___,
    _XX_X___,
    ____X___,
    X___X___,
    _XXX____,
// 254 $fe 'thorn'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    X_______,
    X_______,
    X_XX____,
    XX__X___,
    X___X___,
    X___X___,
    XX__X___,
    X_XX____,
    X_______,
    X_______,
// 255 $ff 'ydieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _X_X____,
    _X_X____,
    ________,
    X___X___,
    X___X___,
    X___X___,
    X__XX___,
    _XX_X___,
    ____X___,
    X___X___,
    _XXX____
};



const unsigned char font_6x13B[] = {
//  32 $20 'space'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
//  33 $21 'exclam'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    ________,
    __XX____,
    ________,
    ________,
//  34 $22 'quotedbl'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX_XX___,
    XX_XX___,
    XX_XX___,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
//  35 $23 'numbersign'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    _XXXX___,
    _XXXX___,
    XXXXXX__,
    _XXXX___,
    XXXXXX__,
    _XXXX___,
    _XXXX___,
    ________,
    ________,
    ________,
//  36 $24 'dollar'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    __XX____,
    _XXXX___,
    XXXX____,
    _XXXX___,
    __XXXX__,
    _XXXX___,
    __XX____,
    ________,
    ________,
    ________,
//  37 $25 'percent'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XX_XX__,
    XXXXXX__,
    _XXXX___,
    ___XX___,
    __XX____,
    _XX_____,
    _XXXX___,
    XXXXXX__,
    XX_XX___,
    ________,
    ________,
//  38 $26 'ampersand'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    _XX_____,
    XXXX____,
    XXXX____,
    _XX_____,
    XXXXXX__,
    XX_XX___,
    _XXXXX__,
    ________,
    ________,
//  39 $27 'quotesingle'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    __XX____,
    __XX____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
//  40 $28 'parenleft'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___XX___,
    __XX____,
    __XX____,
    _XX_____,
    _XX_____,
    _XX_____,
    _XX_____,
    _XX_____,
    __XX____,
    __XX____,
    ___XX___,
    ________,
//  41 $29 'parenright'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XX_____,
    __XX____,
    __XX____,
    ___XX___,
    ___XX___,
    ___XX___,
    ___XX___,
    ___XX___,
    __XX____,
    __XX____,
    _XX_____,
    ________,
//  42 $2a 'asterisk'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    XX__XX__,
    _XXXX___,
    XXXXXX__,
    _XXXX___,
    XX__XX__,
    ________,
    ________,
    ________,
    ________,
//  43 $2b 'plus'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    __XX____,
    __XX____,
    XXXXXX__,
    __XX____,
    __XX____,
    ________,
    ________,
    ________,
    ________,
//  44 $2c 'comma'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    __XXX___,
    __XX____,
    _XX_____,
    ________,
//  45 $2d 'hyphen'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    XXXXXX__,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
//  46 $2e 'period'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    __XX____,
    _XXXX___,
    __XX____,
    ________,
//  47 $2f 'slash'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ____XX__,
    ____XX__,
    ___XX___,
    ___XX___,
    __XX____,
    _XX_____,
    _XX_____,
    XX______,
    XX______,
    ________,
    ________,
//  48 $30 'zero'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    __XX____,
    ________,
    ________,
//  49 $31 'one'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    _XXX____,
    XXXX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    XXXXXX__,
    ________,
    ________,
//  50 $32 'two'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    ____XX__,
    ___XX___,
    __XX____,
    _XX_____,
    XX______,
    XXXXXX__,
    ________,
    ________,
//  51 $33 'three'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXXX__,
    ____XX__,
    ___XX___,
    __XX____,
    _XXXX___,
    ____XX__,
    ____XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
//  52 $34 'four'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___XX___,
    ___XX___,
    __XXX___,
    _XXXX___,
    _X_XX___,
    XX_XX___,
    XXXXXX__,
    ___XX___,
    ___XX___,
    ________,
    ________,
//  53 $35 'five'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXXX__,
    XX______,
    XX______,
    XXXXX___,
    XXX_XX__,
    ____XX__,
    ____XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
//  54 $36 'six'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XXX___,
    _XX_____,
    XX______,
    XX______,
    XXXXX___,
    XXX_XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
//  55 $37 'seven'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXXX__,
    ____XX__,
    ___XX___,
    ___XX___,
    __XX____,
    __XX____,
    _XX_____,
    _XX_____,
    _XX_____,
    ________,
    ________,
//  56 $38 'eight'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
//  57 $39 'nine'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX_XXX__,
    _XXXXX__,
    ____XX__,
    ____XX__,
    ___XX___,
    _XXX____,
    ________,
    ________,
//  58 $3a 'colon'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    __XX____,
    _XXXX___,
    __XX____,
    ________,
    ________,
    __XX____,
    _XXXX___,
    __XX____,
    ________,
    ________,
//  59 $3b 'semicolon'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    __XX____,
    _XXXX___,
    __XX____,
    ________,
    ________,
    __XXX___,
    __XX____,
    _XX_____,
    ________,
//  60 $3c 'less'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ____XX__,
    ___XX___,
    __XX____,
    _XX_____,
    XX______,
    _XX_____,
    __XX____,
    ___XX___,
    ____XX__,
    ________,
    ________,
//  61 $3d 'equal'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XXXXXX__,
    ________,
    ________,
    XXXXXX__,
    ________,
    ________,
    ________,
    ________,
//  62 $3e 'greater'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX______,
    _XX_____,
    __XX____,
    ___XX___,
    ____XX__,
    ___XX___,
    __XX____,
    _XX_____,
    XX______,
    ________,
    ________,
//  63 $3f 'question'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    ____XX__,
    ___XX___,
    __XX____,
    __XX____,
    ________,
    __XX____,
    ________,
    ________,
//  64 $40 'at'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX_XXX__,
    XXXXXX__,
    XXXXXX__,
    XXXXX___,
    XX______,
    _XXXXX__,
    ________,
    ________,
//  65 $41 'A'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XXXXXX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
//  66 $42 'B'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    _XX_XX__,
    _XX_XX__,
    _XX_XX__,
    _XXXX___,
    _XX_XX__,
    _XX_XX__,
    _XX_XX__,
    XXXXX___,
    ________,
    ________,
//  67 $43 'C'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX______,
    XX______,
    XX______,
    XX______,
    XX______,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
//  68 $44 'D'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    _XX_XX__,
    _XX_XX__,
    _XX_XX__,
    _XX_XX__,
    _XX_XX__,
    _XX_XX__,
    _XX_XX__,
    XXXXX___,
    ________,
    ________,
//  69 $45 'E'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXXX__,
    XX______,
    XX______,
    XX______,
    XXXXX___,
    XX______,
    XX______,
    XX______,
    XXXXXX__,
    ________,
    ________,
//  70 $46 'F'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXXX__,
    XX______,
    XX______,
    XX______,
    XXXXX___,
    XX______,
    XX______,
    XX______,
    XX______,
    ________,
    ________,
//  71 $47 'G'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX______,
    XX______,
    XX______,
    XX_XXX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
//  72 $48 'H'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XXXXXX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
//  73 $49 'I'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    _XXXX___,
    ________,
    ________,
//  74 $4a 'J'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XXXX__,
    ____XX__,
    ____XX__,
    ____XX__,
    ____XX__,
    ____XX__,
    ____XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
//  75 $4b 'K'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    XX_XX___,
    XXXX____,
    XXX_____,
    XXXX____,
    XX_XX___,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
//  76 $4c 'L'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX______,
    XX______,
    XX______,
    XX______,
    XX______,
    XX______,
    XX______,
    XX______,
    XXXXXX__,
    ________,
    ________,
//  77 $4d 'M'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    XXXXXX__,
    XXXXXX__,
    XXXXXX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
//  78 $4e 'N'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX__XX__,
    XXX_XX__,
    XXX_XX__,
    XXXXXX__,
    XXXXXX__,
    XX_XXX__,
    XX_XXX__,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
//  79 $4f 'O'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
//  80 $50 'P'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XXXXX___,
    XX______,
    XX______,
    XX______,
    XX______,
    ________,
    ________,
//  81 $51 'Q'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XXXXXX__,
    _XXXX___,
    ____XX__,
    ________,
//  82 $52 'R'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XXXXX___,
    XXXX____,
    XX_XX___,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
//  83 $53 'S'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX______,
    XX______,
    _XXXX___,
    ____XX__,
    ____XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
//  84 $54 'T'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXXX__,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    ________,
    ________,
//  85 $55 'U'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
//  86 $56 'V'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    _XXXX___,
    _XXXX___,
    __XX____,
    __XX____,
    ________,
    ________,
//  87 $57 'W'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XXXXXX__,
    XXXXXX__,
    XXXXXX__,
    XXXXXX__,
    XX__XX__,
    ________,
    ________,
//  88 $58 'X'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    _XXXX___,
    __XX____,
    _XXXX___,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
//  89 $59 'Y'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    _XXXX___,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    ________,
    ________,
//  90 $5a 'Z'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXXX__,
    ____XX__,
    ___XX___,
    ___XX___,
    __XX____,
    _XX_____,
    _XX_____,
    XX______,
    XXXXXX__,
    ________,
    ________,
//  91 $5b 'bracketleft'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XXXX___,
    _XX_____,
    _XX_____,
    _XX_____,
    _XX_____,
    _XX_____,
    _XX_____,
    _XX_____,
    _XX_____,
    _XX_____,
    _XXXX___,
    ________,
//  92 $5c 'backslash'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX______,
    XX______,
    _XX_____,
    _XX_____,
    __XX____,
    ___XX___,
    ___XX___,
    ____XX__,
    ____XX__,
    ________,
    ________,
//  93 $5d 'bracketright'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XXXX___,
    ___XX___,
    ___XX___,
    ___XX___,
    ___XX___,
    ___XX___,
    ___XX___,
    ___XX___,
    ___XX___,
    ___XX___,
    _XXXX___,
    ________,
//  94 $5e 'asciicircum'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    _XXXX___,
    XX__XX__,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
//  95 $5f 'underscore'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    XXXXXX__,
    ________,
//  96 $60 'grave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XX_____,
    __XX____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
//  97 $61 'a'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXXX___,
    ____XX__,
    _XXXXX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ________,
    ________,
//  98 $62 'b'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX______,
    XX______,
    XX______,
    XX_XX___,
    XXX_XX__,
    XX__XX__,
    XX__XX__,
    XXX_XX__,
    XX_XX___,
    ________,
    ________,
//  99 $63 'c'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX______,
    XX______,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 100 $64 'd'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ____XX__,
    ____XX__,
    ____XX__,
    _XX_XX__,
    XX_XXX__,
    XX__XX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ________,
    ________,
// 101 $65 'e'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XXXXXX__,
    XX______,
    XX______,
    _XXXX___,
    ________,
    ________,
// 102 $66 'f'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XXX___,
    _XX_XX__,
    _XX_____,
    _XX_____,
    XXXXX___,
    _XX_____,
    _XX_____,
    _XX_____,
    _XX_____,
    ________,
    ________,
// 103 $67 'g'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXXXX__,
    XX_XX___,
    XX_XX___,
    _XXX____,
    XX______,
    _XXXX___,
    XX__XX__,
    _XXXX___,
// 104 $68 'h'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX______,
    XX______,
    XX______,
    XX_XX___,
    XXX_XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
// 105 $69 'i'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    __XX____,
    ________,
    _XXX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    _XXXX___,
    ________,
    ________,
// 106 $6a 'j'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___XX___,
    ___XX___,
    ________,
    __XXX___,
    ___XX___,
    ___XX___,
    ___XX___,
    ___XX___,
    XX_XX___,
    XX_XX___,
    _XXX____,
// 107 $6b 'k'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX______,
    XX______,
    XX______,
    XX_XX___,
    XXXX____,
    XXX_____,
    XXXX____,
    XX_XX___,
    XX__XX__,
    ________,
    ________,
// 108 $6c 'l'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    _XXXX___,
    ________,
    ________,
// 109 $6d 'm'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XXXXX___,
    XXXXXX__,
    XXXXXX__,
    XXXXXX__,
    XXXXXX__,
    XX__XX__,
    ________,
    ________,
// 110 $6e 'n'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XX_XX___,
    XXX_XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
// 111 $6f 'o'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 112 $70 'p'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XX_XX___,
    XXX_XX__,
    XX__XX__,
    XXX_XX__,
    XX_XX___,
    XX______,
    XX______,
    XX______,
// 113 $71 'q'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XX_XX__,
    XX_XXX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ____XX__,
    ____XX__,
    ____XX__,
// 114 $72 'r'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XX_XX___,
    XXX_XX__,
    XX______,
    XX______,
    XX______,
    XX______,
    ________,
    ________,
// 115 $73 's'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    _XXX____,
    ___XX___,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 116 $74 't'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    _XX_____,
    _XX_____,
    XXXXX___,
    _XX_____,
    _XX_____,
    _XX_____,
    _XX_XX__,
    __XXX___,
    ________,
    ________,
// 117 $75 'u'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ________,
    ________,
// 118 $76 'v'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    _XXXX___,
    __XX____,
    ________,
    ________,
// 119 $77 'w'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    XXXXXX__,
    XXXXXX__,
    XXXXXX__,
    _X__X___,
    ________,
    ________,
// 120 $78 'x'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XX__XX__,
    _XXXX___,
    __XX____,
    __XX____,
    _XXXX___,
    XX__XX__,
    ________,
    ________,
// 121 $79 'y'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ____XX__,
    XX__XX__,
    _XXXX___,
// 122 $7a 'z'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XXXXXX__,
    ___XX___,
    __XX____,
    _XX_____,
    XX______,
    XXXXXX__,
    ________,
    ________,
// 123 $7b 'braceleft'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XXX___,
    _XX_____,
    _XX_____,
    _XX_____,
    __XX____,
    XXX_____,
    __XX____,
    _XX_____,
    _XX_____,
    _XX_____,
    __XXX___,
    ________,
// 124 $7c 'bar'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    ________,
    ________,
// 125 $7d 'braceright'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    XXX_____,
    __XX____,
    __XX____,
    __XX____,
    _XX_____,
    __XXX___,
    _XX_____,
    __XX____,
    __XX____,
    __XX____,
    XXX_____,
    ________,
// 126 $7e 'asciitilde'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XX_X___,
    XXXXX___,
    X__X____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 160 $a0 'space'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 161 $a1 'exclamdown'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX____,
    __XX____,
    ________,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    ________,
    ________,
// 162 $a2 'cent'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___X____,
    _XXXX___,
    XX_X_X__,
    XX_X____,
    XX_X____,
    XX_X_X__,
    _XXXX___,
    ___X____,
    ________,
    ________,
    ________,
// 163 $a3 'sterling'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XXX___,
    _XX_XX__,
    _XX_____,
    _XX_____,
    XXXXX___,
    _XX_____,
    _XX_____,
    _XX__X__,
    XXXXX___,
    ________,
    ________,
// 164 $a4 'currency'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    XX__XX__,
    XXXXXX__,
    _X__X___,
    _X__X___,
    XXXXXX__,
    XX__XX__,
    ________,
    ________,
    ________,
// 165 $a5 'yen'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    _XXXX___,
    XXXXXX__,
    __XX____,
    XXXXXX__,
    __XX____,
    __XX____,
    ________,
    ________,
// 166 $a6 'brokenbar'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    ________,
    ________,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    ________,
    ________,
// 167 $a7 'section'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XXXX___,
    XX__XX__,
    XX______,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ____XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 168 $a8 'dieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 169 $a9 'copyright'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    X_XX_X__,
    XXX_XX__,
    XXX__X__,
    XXX_XX__,
    X_XX_X__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 170 $aa 'ordfeminine'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    ____XX__,
    XXXXXX__,
    X___XX__,
    XXXXXX__,
    ________,
    XXXXXX__,
    ________,
    ________,
    ________,
    ________,
// 171 $ab 'guillemotleft'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    __XX_X__,
    _XX_X___,
    XX_X____,
    X_X_____,
    XX_X____,
    _XX_X___,
    __XX_X__,
    ________,
    ________,
    ________,
// 172 $ac 'logicalnot'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XXXXXX__,
    XXXXXX__,
    _____X__,
    _____X__,
    ________,
    ________,
    ________,
    ________,
// 173 $ad 'hyphen'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXXX___,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 174 $ae 'registered'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    X_XXXX__,
    X_X_XX__,
    X_XXXX__,
    X_XX_X__,
    X_X_XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 175 $af 'macron'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    XXXXX___,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 176 $b0 'degree'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 177 $b1 'plusminus'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX____,
    __XX____,
    XXXXXX__,
    XXXXXX__,
    __XX____,
    __XX____,
    ________,
    XXXXXX__,
    XXXXXX__,
    ________,
    ________,
// 178 $b2 'twosuperior'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    XXX_____,
    X_XX____,
    __XX____,
    _XX_____,
    XX______,
    XXXX____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 179 $b3 'threesuperior'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    XXX_____,
    X_XX____,
    _XX_____,
    __XX____,
    X_XX____,
    XXX_____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 180 $b4 'acute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX____,
    _XX_____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 181 $b5 'mu'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XXXXXX__,
    X_______,
    X_______,
// 182 $b6 'paragraph'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXXX__,
    XXXXXX__,
    XXXX_X__,
    XXXX_X__,
    XXXX_X__,
    _XXX_X__,
    __XX_X__,
    __XX_X__,
    __XX_X__,
    ________,
    ________,
// 183 $b7 'periodcentered'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    __XX____,
    __XX____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 184 $b8 'cedilla'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
    __XX____,
    _XX_____,
// 185 $b9 'onesuperior'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XX_____,
    XXX_____,
    _XX_____,
    _XX_____,
    _XX_____,
    XXXX____,
    ________,
    ________,
    ________,
    ________,
    ________,
    ________,
// 186 $ba 'ordmasculine'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XXX____,
    XXXXX___,
    X___X___,
    XXXXX___,
    _XXX____,
    ________,
    XXXXX___,
    ________,
    ________,
    ________,
    ________,
    ________,
// 187 $bb 'guillemotright'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    X_XX____,
    _X_XX___,
    __X_XX__,
    ___X_X__,
    __X_XX__,
    _X_XX___,
    X_XX____,
    ________,
    ________,
    ________,
// 188 $bc 'onequarter'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XX_____,
    XXX_____,
    _XX_____,
    _XX_____,
    _XX__X__,
    XXXXXX__,
    ___XXX__,
    __XX_X__,
    __XXXX__,
    ____XX__,
    ________,
    ________,
// 189 $bd 'onehalf'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XX_____,
    XXX_____,
    _XX_____,
    _XX_____,
    _XXXX___,
    XXX_XX__,
    ____XX__,
    ___XX___,
    __XX____,
    __XXXX__,
    ________,
    ________,
// 190 $be 'threequarters'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    XXX_____,
    X_XX____,
    _XX_____,
    __XX____,
    X_XX_X__,
    XXX_XX__,
    ___XXX__,
    __XX_X__,
    __XXXX__,
    ____XX__,
    ________,
    ________,
// 191 $bf 'questiondown'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX____,
    __XX____,
    ________,
    __XX____,
    __XX____,
    _XX_____,
    XX______,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 192 $c0 'Agrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XX_____,
    __XX____,
    ________,
    __XX____,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XXXXXX__,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
// 193 $c1 'Aacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___XX___,
    __XX____,
    ________,
    __XX____,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XXXXXX__,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
// 194 $c2 'Acircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XXX___,
    _XX_XX__,
    ________,
    __XX____,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XXXXXX__,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
// 195 $c3 'Atilde'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX_X__,
    _X_XX___,
    ________,
    __XX____,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XXXXXX__,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
// 196 $c4 'Adieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    XX__XX__,
    XX__XX__,
    ________,
    __XX____,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XXXXXX__,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
// 197 $c5 'Aring'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX____,
    _X__X___,
    _XXXX___,
    __XX____,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XXXXXX__,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
// 198 $c6 'AE'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXXX__,
    X_XX____,
    X_XX____,
    X_XX____,
    X_XXX___,
    XXXX____,
    XXXX____,
    X_XX____,
    X_XXXX__,
    ________,
    ________,
// 199 $c7 'Ccedilla'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX______,
    XX______,
    XX______,
    XX______,
    XX______,
    XX__XX__,
    _XXXX___,
    __XX____,
    _XX_____,
// 200 $c8 'Egrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XX_____,
    __XX____,
    ________,
    XXXXXX__,
    XX______,
    XX______,
    XXXXX___,
    XX______,
    XX______,
    XXXXXX__,
    ________,
    ________,
// 201 $c9 'Eacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___XX___,
    __XX____,
    ________,
    XXXXXX__,
    XX______,
    XX______,
    XXXXX___,
    XX______,
    XX______,
    XXXXXX__,
    ________,
    ________,
// 202 $ca 'Ecircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XXX___,
    _XX_XX__,
    ________,
    XXXXXX__,
    XX______,
    XX______,
    XXXXX___,
    XX______,
    XX______,
    XXXXXX__,
    ________,
    ________,
// 203 $cb 'Edieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    XX__XX__,
    XX__XX__,
    ________,
    XXXXXX__,
    XX______,
    XX______,
    XXXXX___,
    XX______,
    XX______,
    XXXXXX__,
    ________,
    ________,
// 204 $cc 'Igrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XX_____,
    __XX____,
    ________,
    _XXXX___,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    _XXXX___,
    ________,
    ________,
// 205 $cd 'Iacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___XX___,
    __XX____,
    ________,
    _XXXX___,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    _XXXX___,
    ________,
    ________,
// 206 $ce 'Icircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XXX____,
    XX_XX___,
    ________,
    _XXXX___,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    _XXXX___,
    ________,
    ________,
// 207 $cf 'Idieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    XX__XX__,
    XX__XX__,
    ________,
    _XXXX___,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    _XXXX___,
    ________,
    ________,
// 208 $d0 'Eth'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XXXXX___,
    _XX_XX__,
    _XX_XX__,
    _XX_XX__,
    XXX_XX__,
    _XX_XX__,
    _XX_XX__,
    _XX_XX__,
    XXXXX___,
    ________,
    ________,
// 209 $d1 'Ntilde'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX_X__,
    _X_XX___,
    ________,
    XX__XX__,
    XXX_XX__,
    XXX_XX__,
    XXXXXX__,
    XX_XXX__,
    XX_XXX__,
    XX__XX__,
    ________,
    ________,
// 210 $d2 'Ograve'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XX_____,
    __XX____,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 211 $d3 'Oacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___XX___,
    __XX____,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 212 $d4 'Ocircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XXX___,
    _XX_XX__,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 213 $d5 'Otilde'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XX_X__,
    _X_XX___,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 214 $d6 'Odieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    XX__XX__,
    XX__XX__,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 215 $d7 'multiply'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    XX__XX__,
    _XXXX___,
    __XX____,
    _XXXX___,
    XX__XX__,
    ________,
    ________,
    ________,
// 216 $d8 'Oslash'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    _____X__,
    _XXXX___,
    XX_XXX__,
    XX_XXX__,
    XX__XX__,
    XXX_XX__,
    XXX_XX__,
    _XXXX___,
    X_______,
    ________,
// 217 $d9 'Ugrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XX_____,
    __XX____,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 218 $da 'Uacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___XX___,
    __XX____,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 219 $db 'Ucircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XXX___,
    _XX_XX__,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 220 $dc 'Udieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    _XX_XX__,
    _XX_XX__,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 221 $dd 'Yacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ___XX___,
    __XX____,
    ________,
    XX__XX__,
    _X__X___,
    _XXXX___,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    ________,
    ________,
// 222 $de 'Thorn'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX______,
    XXXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XXXXX___,
    XX______,
    XX______,
    XX______,
    ________,
    ________,
// 223 $df 'germandbls'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XXXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XXXXX___,
    X_______,
    ________,
// 224 $e0 'agrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XX_____,
    __XX____,
    ________,
    _XXXX___,
    ____XX__,
    _XXXXX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ________,
    ________,
// 225 $e1 'aacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___XX___,
    __XX____,
    ________,
    _XXXX___,
    ____XX__,
    _XXXXX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ________,
    ________,
// 226 $e2 'acircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XXX___,
    _XX_XX__,
    ________,
    _XXXX___,
    ____XX__,
    _XXXXX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ________,
    ________,
// 227 $e3 'atilde'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX_X__,
    _X_XX___,
    ________,
    _XXXX___,
    ____XX__,
    _XXXXX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ________,
    ________,
// 228 $e4 'adieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XX_XX__,
    _XX_XX__,
    ________,
    _XXXX___,
    ____XX__,
    _XXXXX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ________,
    ________,
// 229 $e5 'aring'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    __XXX___,
    __X_X___,
    __XXX___,
    ________,
    _XXXX___,
    ____XX__,
    _XXXXX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ________,
    ________,
// 230 $e6 'ae'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXXX___,
    __XX_X__,
    _XXXX___,
    X_XX____,
    X_XX_X__,
    _XX_X___,
    ________,
    ________,
// 231 $e7 'ccedilla'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    ________,
    ________,
    _XXXX___,
    XX__XX__,
    XX______,
    XX______,
    XX__XX__,
    _XXXX___,
    __XX____,
    _XX_____,
// 232 $e8 'egrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XX_____,
    __XX____,
    ________,
    _XXXX___,
    XX__XX__,
    XXXXXX__,
    XX______,
    XX______,
    _XXXX___,
    ________,
    ________,
// 233 $e9 'eacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___XX___,
    __XX____,
    ________,
    _XXXX___,
    XX__XX__,
    XXXXXX__,
    XX______,
    XX______,
    _XXXX___,
    ________,
    ________,
// 234 $ea 'ecircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XXX___,
    _XX_XX__,
    ________,
    _XXXX___,
    XX__XX__,
    XXXXXX__,
    XX______,
    XX______,
    _XXXX___,
    ________,
    ________,
// 235 $eb 'edieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XX_XX__,
    _XX_XX__,
    ________,
    _XXXX___,
    XX__XX__,
    XXXXXX__,
    XX______,
    XX______,
    _XXXX___,
    ________,
    ________,
// 236 $ec 'igrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XX_____,
    __XX____,
    ________,
    _XXX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    _XXXX___,
    ________,
    ________,
// 237 $ed 'iacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___XX___,
    __XX____,
    ________,
    _XXX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    _XXXX___,
    ________,
    ________,
// 238 $ee 'icircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XXX____,
    XX_XX___,
    ________,
    _XXX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    _XXXX___,
    ________,
    ________,
// 239 $ef 'idieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX_XX___,
    XX_XX___,
    ________,
    _XXX____,
    __XX____,
    __XX____,
    __XX____,
    __XX____,
    _XXXX___,
    ________,
    ________,
// 240 $f0 'eth'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    XX_XX___,
    _XXX____,
    XXXX____,
    X__XX___,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 241 $f1 'ntilde'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX_X__,
    _X_XX___,
    ________,
    XX_XX___,
    XXX_XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    ________,
    ________,
// 242 $f2 'ograve'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XX_____,
    __XX____,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 243 $f3 'oacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___XX___,
    __XX____,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 244 $f4 'ocircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XXX___,
    _XX_XX__,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 245 $f5 'otilde'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XX_X__,
    _X_XX___,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 246 $f6 'odieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    ________,
    _XXXX___,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    _XXXX___,
    ________,
    ________,
// 247 $f7 'divide'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    __XX____,
    __XX____,
    ________,
    XXXXXX__,
    ________,
    __XX____,
    __XX____,
    ________,
    ________,
    ________,
// 248 $f8 'oslash'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    _____X__,
    _XXXX___,
    XX__XX__,
    XX_XXX__,
    XX__XX__,
    XXX_XX__,
    XX__XX__,
    _XXXX___,
    X_______,
    ________,
// 249 $f9 'ugrave'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    _XX_____,
    __XX____,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ________,
    ________,
// 250 $fa 'uacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___XX___,
    __XX____,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ________,
    ________,
// 251 $fb 'ucircumflex'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    __XXX___,
    _XX_XX__,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ________,
    ________,
// 252 $fc 'udieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ________,
    ________,
// 253 $fd 'yacute'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ___XX___,
    __XX____,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ____XX__,
    XX__XX__,
    _XXXX___,
// 254 $fe 'thorn'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    ________,
    XX______,
    XX______,
    XX_XX___,
    XXX_XX__,
    XX__XX__,
    XXX_XX__,
    XX_XX___,
    XX______,
    XX______,
    XX______,
// 255 $ff 'ydieresis'
//    width 6, bbx 0, bby -2, bbw 6, bbh 13
    ________,
    ________,
    XX__XX__,
    XX__XX__,
    ________,
    XX__XX__,
    XX__XX__,
    XX__XX__,
    XX_XXX__,
    _XX_XX__,
    ____XX__,
    XX__XX__,
    _XXXX___
};


    /// character bitmap for each encoding
static const unsigned char font_9x15[] = {
//  32 $20 'space'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  33 $21 'exclam'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    ________,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    ________,________,
    ________,________,
//  34 $22 'quotedbl'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___X__X_,________,
    ___X__X_,________,
    ___X__X_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  35 $23 'numbersign'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    __X__X__,________,
    __X__X__,________,
    _XXXXXX_,________,
    __X__X__,________,
    __X__X__,________,
    _XXXXXX_,________,
    __X__X__,________,
    __X__X__,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  36 $24 'dollar'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____X___,________,
    __XXXXX_,________,
    _X__X__X,________,
    _X__X___,________,
    __X_X___,________,
    ___XXX__,________,
    ____X_X_,________,
    ____X__X,________,
    _X__X__X,________,
    __XXXXX_,________,
    ____X___,________,
    ________,________,
    ________,________,
//  37 $25 'percent'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __X____X,________,
    _X_X__X_,________,
    _X_X__X_,________,
    __X__X__,________,
    ____X___,________,
    ____X___,________,
    ___X__X_,________,
    __X__X_X,________,
    __X__X_X,________,
    _X____X_,________,
    ________,________,
    ________,________,
    ________,________,
//  38 $26 'ampersand'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XX____,________,
    _X__X___,________,
    _X__X___,________,
    _X__X___,________,
    __XX____,________,
    __XX___X,________,
    _X__X_X_,________,
    _X___X__,________,
    _X__X_X_,________,
    __XX___X,________,
    ________,________,
    ________,________,
    ________,________,
//  39 $27 'quotesingle'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  40 $28 'parenleft'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _____X__,________,
    ____X___,________,
    ____X___,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ____X___,________,
    ____X___,________,
    _____X__,________,
    ________,________,
    ________,________,
//  41 $29 'parenright'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ___X____,________,
    ____X___,________,
    ____X___,________,
    _____X__,________,
    _____X__,________,
    _____X__,________,
    _____X__,________,
    _____X__,________,
    _____X__,________,
    ____X___,________,
    ____X___,________,
    ___X____,________,
    ________,________,
    ________,________,
//  42 $2a 'asterisk'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____X___,________,
    _X__X__X,________,
    __X_X_X_,________,
    ___XXX__,________,
    __X_X_X_,________,
    _X__X__X,________,
    ____X___,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  43 $2b 'plus'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    _XXXXXXX,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  44 $2c 'comma'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ____XX__,________,
    ____XX__,________,
    _____X__,________,
    _____X__,________,
    ____X___,________,
//  45 $2d 'hyphen'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  46 $2e 'period'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ____XX__,________,
    ____XX__,________,
    ________,________,
    ________,________,
    ________,________,
//  47 $2f 'slash'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _______X,________,
    ______X_,________,
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ____X___,________,
    ___X____,________,
    __X_____,________,
    __X_____,________,
    _X______,________,
    ________,________,
    ________,________,
    ________,________,
//  48 $30 'zero'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XXX__,________,
    __X___X_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __X___X_,________,
    ___XXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  49 $31 'one'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____X___,________,
    ___XX___,________,
    __X_X___,________,
    _X__X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
//  50 $32 'two'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ___X____,________,
    __X_____,________,
    _X______,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
//  51 $33 'three'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXXX,________,
    _______X,________,
    ______X_,________,
    _____X__,________,
    ____XXX_,________,
    _______X,________,
    _______X,________,
    _______X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  52 $34 'four'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ______X_,________,
    _____XX_,________,
    ____X_X_,________,
    ___X__X_,________,
    __X___X_,________,
    _X____X_,________,
    _XXXXXXX,________,
    ______X_,________,
    ______X_,________,
    ______X_,________,
    ________,________,
    ________,________,
    ________,________,
//  53 $35 'five'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXXX,________,
    _X______,________,
    _X______,________,
    _X_XXXX_,________,
    _XX____X,________,
    _______X,________,
    _______X,________,
    _______X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  54 $36 'six'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XXXX_,________,
    __X_____,________,
    _X______,________,
    _X______,________,
    _X_XXXX_,________,
    _XX____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  55 $37 'seven'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXXX,________,
    _______X,________,
    ______X_,________,
    ______X_,________,
    _____X__,________,
    _____X__,________,
    ____X___,________,
    ____X___,________,
    ___X____,________,
    ___X____,________,
    ________,________,
    ________,________,
    ________,________,
//  56 $38 'eight'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XXX__,________,
    __X___X_,________,
    _X_____X,________,
    __X___X_,________,
    ___XXX__,________,
    __X___X_,________,
    _X_____X,________,
    _X_____X,________,
    __X___X_,________,
    ___XXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  57 $39 'nine'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X____XX,________,
    __XXXX_X,________,
    _______X,________,
    _______X,________,
    ______X_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  58 $3a 'colon'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ____XX__,________,
    ____XX__,________,
    ________,________,
    ________,________,
    ________,________,
    ____XX__,________,
    ____XX__,________,
    ________,________,
    ________,________,
    ________,________,
//  59 $3b 'semicolon'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ____XX__,________,
    ____XX__,________,
    ________,________,
    ________,________,
    ________,________,
    ____XX__,________,
    ____XX__,________,
    _____X__,________,
    _____X__,________,
    ____X___,________,
//  60 $3c 'less'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ___X____,________,
    __X_____,________,
    __X_____,________,
    ___X____,________,
    ____X___,________,
    _____X__,________,
    ______X_,________,
    ________,________,
    ________,________,
    ________,________,
//  61 $3d 'equal'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  62 $3e 'greater'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __X_____,________,
    ___X____,________,
    ____X___,________,
    _____X__,________,
    ______X_,________,
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ___X____,________,
    __X_____,________,
    ________,________,
    ________,________,
    ________,________,
//  63 $3f 'question'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _______X,________,
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    ____X___,________,
    ________,________,
    ________,________,
    ________,________,
//  64 $40 'at'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X__XXXX,________,
    _X_X___X,________,
    _X_X__XX,________,
    _X__XX_X,________,
    _X______,________,
    _X______,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  65 $41 'A'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____X___,________,
    ___X_X__,________,
    __X___X_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXXX,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
//  66 $42 'B'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXX__,________,
    _X____X_,________,
    _X_____X,________,
    _X____X_,________,
    _XXXXX__,________,
    _X____X_,________,
    _X_____X,________,
    _X_____X,________,
    _X____X_,________,
    _XXXXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  67 $43 'C'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  68 $44 'D'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXX__,________,
    _X____X_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X____X_,________,
    _XXXXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  69 $45 'E'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXXX,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _XXXXX__,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
//  70 $46 'F'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXXX,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _XXXXX__,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    ________,________,
    ________,________,
    ________,________,
//  71 $47 'G'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X___XXX,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  72 $48 'H'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXXX,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
//  73 $49 'I'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  74 $4a 'J'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____XXXX,X_______,
    ______X_,________,
    ______X_,________,
    ______X_,________,
    ______X_,________,
    ______X_,________,
    ______X_,________,
    ______X_,________,
    _X____X_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  75 $4b 'K'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X_____X,________,
    _X____X_,________,
    _X___X__,________,
    _X__X___,________,
    _XXX____,________,
    _X_X____,________,
    _X__X___,________,
    _X___X__,________,
    _X____X_,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
//  76 $4c 'L'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
//  77 $4d 'M'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    _XX___XX,________,
    _X_X_X_X,________,
    _X_X_X_X,________,
    _X__X__X,________,
    _X__X__X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
//  78 $4e 'N'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    _XX____X,________,
    _X_X___X,________,
    _X__X__X,________,
    _X___X_X,________,
    _X____XX,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
//  79 $4f 'O'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  80 $50 'P'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXX_,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    ________,________,
    ________,________,
    ________,________,
//  81 $51 'Q'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_X___X,________,
    _X__X__X,________,
    __XXXXX_,________,
    _____X__,________,
    ______XX,________,
    ________,________,
//  82 $52 'R'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXX_,________,
    _X__X___,________,
    _X___X__,________,
    _X____X_,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
//  83 $53 'S'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X______,________,
    __XXX___,________,
    _____XX_,________,
    _______X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  84 $54 'T'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXXX,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    ________,________,
    ________,________,
//  85 $55 'U'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  86 $56 'V'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __X___X_,________,
    __X___X_,________,
    __X___X_,________,
    ___X_X__,________,
    ___X_X__,________,
    ___X_X__,________,
    ____X___,________,
    ________,________,
    ________,________,
    ________,________,
//  87 $57 'W'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X__X__X,________,
    _X__X__X,________,
    _X__X__X,________,
    _X__X__X,________,
    _X_X_X_X,________,
    __X___X_,________,
    ________,________,
    ________,________,
    ________,________,
//  88 $58 'X'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    __X___X_,________,
    ___X_X__,________,
    ____X___,________,
    ____X___,________,
    ___X_X__,________,
    __X___X_,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
//  89 $59 'Y'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    __X___X_,________,
    ___X_X__,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    ________,________,
    ________,________,
//  90 $5a 'Z'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXXX,________,
    _______X,________,
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ___X____,________,
    __X_____,________,
    _X______,________,
    _X______,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
//  91 $5b 'bracketleft'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ___XXXX_,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ___XXXX_,________,
    ________,________,
    ________,________,
//  92 $5c 'backslash'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X______,________,
    __X_____,________,
    __X_____,________,
    ___X____,________,
    ____X___,________,
    ____X___,________,
    _____X__,________,
    ______X_,________,
    ______X_,________,
    _______X,________,
    ________,________,
    ________,________,
    ________,________,
//  93 $5d 'bracketright'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XXXX__,________,
    _____X__,________,
    _____X__,________,
    _____X__,________,
    _____X__,________,
    _____X__,________,
    _____X__,________,
    _____X__,________,
    _____X__,________,
    _____X__,________,
    _____X__,________,
    __XXXX__,________,
    ________,________,
    ________,________,
//  94 $5e 'asciicircum'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____X___,________,
    ___X_X__,________,
    __X___X_,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  95 $5f 'underscore'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    XXXXXXXX,________,
    ________,________,
    ________,________,
//  96 $60 'grave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ___X____,________,
    ____X___,________,
    _____X__,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  97 $61 'a'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXXXX_,________,
    _______X,________,
    _______X,________,
    __XXXXXX,________,
    _X_____X,________,
    _X____XX,________,
    __XXXX_X,________,
    ________,________,
    ________,________,
    ________,________,
//  98 $62 'b'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X_XXXX_,________,
    _XX____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _XX____X,________,
    _X_XXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  99 $63 'c'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 100 $64 'd'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _______X,________,
    _______X,________,
    _______X,________,
    __XXXX_X,________,
    _X____XX,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X____XX,________,
    __XXXX_X,________,
    ________,________,
    ________,________,
    ________,________,
// 101 $65 'e'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXXX,________,
    _X______,________,
    _X______,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 102 $66 'f'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____XXX_,________,
    ___X___X,________,
    ___X___X,________,
    ___X____,________,
    ___X____,________,
    _XXXXX__,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ________,________,
    ________,________,
    ________,________,
// 103 $67 'g'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXXX_X,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    __XXXX__,________,
    _X______,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
// 104 $68 'h'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X_XXXX_,________,
    _XX____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
// 105 $69 'i'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XX___,________,
    ________,________,
    ________,________,
    __XXX___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 106 $6a 'j'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _____XX_,________,
    ________,________,
    ________,________,
    ____XXX_,________,
    ______X_,________,
    ______X_,________,
    ______X_,________,
    ______X_,________,
    ______X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    __XXXX__,________,
// 107 $6b 'k'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X_____X,________,
    _X___XX_,________,
    _X_XX___,________,
    _XX_____,________,
    _X_XX___,________,
    _X___XX_,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
// 108 $6c 'l'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXX___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 109 $6d 'm'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _XXX_XX_,________,
    _X__X__X,________,
    _X__X__X,________,
    _X__X__X,________,
    _X__X__X,________,
    _X__X__X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
// 110 $6e 'n'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _X_XXXX_,________,
    _XX____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
// 111 $6f 'o'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 112 $70 'p'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _X_XXXX_,________,
    _XX____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _XX____X,________,
    _X_XXXX_,________,
    _X______,________,
    _X______,________,
    _X______,________,
// 113 $71 'q'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXXX_X,________,
    _X____XX,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X____XX,________,
    __XXXX_X,________,
    _______X,________,
    _______X,________,
    _______X,________,
// 114 $72 'r'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _X__XXX_,________,
    __XX___X,________,
    __X____X,________,
    __X_____,________,
    __X_____,________,
    __X_____,________,
    __X_____,________,
    ________,________,
    ________,________,
    ________,________,
// 115 $73 's'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X______,________,
    __XXXXX_,________,
    _______X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 116 $74 't'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ___X____,________,
    ___X____,________,
    _XXXXXX_,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ___X____,________,
    ___X___X,________,
    ____XXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 117 $75 'u'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    __XXXX_X,________,
    ________,________,
    ________,________,
    ________,________,
// 118 $76 'v'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    __X___X_,________,
    __X___X_,________,
    ___X_X__,________,
    ___X_X__,________,
    ____X___,________,
    ________,________,
    ________,________,
    ________,________,
// 119 $77 'w'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    _X__X__X,________,
    _X__X__X,________,
    _X__X__X,________,
    _X_X_X_X,________,
    __X___X_,________,
    ________,________,
    ________,________,
    ________,________,
// 120 $78 'x'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _X_____X,________,
    __X___X_,________,
    ___X_X__,________,
    ____X___,________,
    ___X_X__,________,
    __X___X_,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
// 121 $79 'y'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X___XX_,________,
    __XXX_X_,________,
    ______X_,________,
    _X____X_,________,
    __XXXX__,________,
// 122 $7a 'z'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _XXXXXXX,________,
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ___X____,________,
    __X_____,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
// 123 $7b 'braceleft'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _____XXX,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    _____X__,________,
    ___XX___,________,
    ___XX___,________,
    _____X__,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    _____XXX,________,
    ________,________,
    ________,________,
// 124 $7c 'bar'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    ________,________,
// 125 $7d 'braceright'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XXX____,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ___X____,________,
    ____XX__,________,
    ____XX__,________,
    ___X____,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    _XXX____,________,
    ________,________,
    ________,________,
// 126 $7e 'asciitilde'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XX___X,________,
    _X__X__X,________,
    _X___XX_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 160 $a0 'space'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 161 $a1 'exclamdown'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    ________,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    ________,________,
    ________,________,
// 162 $a2 'cent'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _____X__,________,
    __XXXX__,________,
    _X__X_X_,________,
    _X__X___,________,
    _X_X____,________,
    _X_X__X_,________,
    __XXXX__,________,
    __X_____,________,
    ________,________,
    ________,________,
    ________,________,
// 163 $a3 'sterling'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____XXX_,________,
    ___X___X,________,
    ___X____,________,
    ___X____,________,
    _XXXXX__,________,
    ___X____,________,
    ___X____,________,
    __XX____,________,
    _X_X___X,________,
    __X_XXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 164 $a4 'currency'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    _X_____X,________,
    __XXXXX_,________,
    __X___X_,________,
    __X___X_,________,
    __XXXXX_,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 165 $a5 'yen'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    __X___X_,________,
    ___X_X__,________,
    __XXXXX_,________,
    ____X___,________,
    __XXXXX_,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    ________,________,
    ________,________,
// 166 $a6 'brokenbar'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    ________,________,
// 167 $a7 'section'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XX___,________,
    __X__X__,________,
    __X_____,________,
    ___XX___,________,
    __X__X__,________,
    __X__X__,________,
    __X__X__,________,
    ___XX___,________,
    _____X__,________,
    __X__X__,________,
    ___XX___,________,
    ________,________,
    ________,________,
// 168 $a8 'dieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __X___X_,________,
    __X___X_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 169 $a9 'copyright'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXX__,________,
    _X____X_,________,
    X__XX__X,________,
    X_X__X_X,________,
    X_X____X,________,
    X_X__X_X,________,
    X__XX__X,________,
    _X____X_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 170 $aa 'ordfeminine'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XX____,________,
    _X__X___,________,
    __XXX___,________,
    _X__X___,________,
    __XXXX__,________,
    ________,________,
    _XXXXX__,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 171 $ab 'guillemotleft'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ____X__X,________,
    ___X__X_,________,
    __X__X__,________,
    _X__X___,________,
    _X__X___,________,
    __X__X__,________,
    ___X__X_,________,
    ____X__X,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 172 $ac 'logicalnot'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _XXXXXX_,________,
    ______X_,________,
    ______X_,________,
    ______X_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 173 $ad 'hyphen'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 174 $ae 'registered'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXX__,________,
    _X____X_,________,
    X_XXX__X,________,
    X_X__X_X,________,
    X_XXX__X,________,
    X_X_X__X,________,
    X_X__X_X,________,
    _X____X_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 175 $af 'macron'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 176 $b0 'degree'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____XX__,________,
    ___X__X_,________,
    ___X__X_,________,
    ____XX__,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 177 $b1 'plusminus'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    _XXXXXXX,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 178 $b2 'twosuperior'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XX____,________,
    _X__X___,________,
    ____X___,________,
    __XX____,________,
    _X______,________,
    _XXXX___,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 179 $b3 'threesuperior'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XX____,________,
    _X__X___,________,
    ___X____,________,
    ____X___,________,
    _X__X___,________,
    __XX____,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 180 $b4 'acute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _____X__,________,
    ____X___,________,
    ___X____,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 181 $b5 'mu'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _XX___XX,________,
    _X_XXX_X,________,
    _X______,________,
    _X______,________,
    ________,________,
// 182 $b6 'paragraph'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXXX,________,
    _X___X_X,________,
    _X___X_X,________,
    _X___X_X,________,
    __XXXX_X,________,
    _____X_X,________,
    _____X_X,________,
    _____X_X,________,
    _____X_X,________,
    _____X_X,________,
    ________,________,
    ________,________,
    ________,________,
// 183 $b7 'periodcentered'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ____XX__,________,
    ____XX__,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 184 $b8 'cedilla'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ____XX__,________,
    __X__X__,________,
    ___XX___,________,
// 185 $b9 'onesuperior'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __X_____,________,
    _XX_____,________,
    __X_____,________,
    __X_____,________,
    __X_____,________,
    _XXX____,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 186 $ba 'ordmasculine'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXX___,________,
    _X___X__,________,
    _X___X__,________,
    __XXX___,________,
    ________,________,
    _XXXXX__,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 187 $bb 'guillemotright'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    _X__X___,________,
    __X__X__,________,
    ___X__X_,________,
    ____X__X,________,
    ____X__X,________,
    ___X__X_,________,
    __X__X__,________,
    _X__X___,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 188 $bc 'onequarter'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __X_____,________,
    _XX_____,________,
    __X_____,________,
    __X_____,________,
    __X____X,________,
    _XXX__XX,________,
    _____X_X,________,
    ____X__X,________,
    ____XX_X,________,
    ______XX,________,
    ________,________,
    ________,________,
    ________,________,
// 189 $bd 'onehalf'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __X_____,________,
    _XX_____,________,
    __X_____,________,
    __X_____,________,
    __X__XX_,________,
    _XXXX__X,________,
    _______X,________,
    _____XX_,________,
    ____X___,________,
    ____XXXX,________,
    ________,________,
    ________,________,
    ________,________,
// 190 $be 'threequarters'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XX____,________,
    _X__X___,________,
    ___X____,________,
    ____X___,________,
    _X__X__X,________,
    __XX__XX,________,
    _____X_X,________,
    ____X__X,________,
    ____XX_X,________,
    ______XX,________,
    ________,________,
    ________,________,
    ________,________,
// 191 $bf 'questiondown'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____X___,________,
    ________,________,
    ____X___,________,
    ____X___,________,
    ___X____,________,
    __X_____,________,
    _X______,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 192 $c0 'Agrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    __X_____,________,
    ___X____,________,
    ____X___,________,
    ________,________,
    ___XXX__,________,
    __X___X_,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXXX,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
// 193 $c1 'Aacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ________,________,
    ___XXX__,________,
    __X___X_,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXXX,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
// 194 $c2 'Acircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ____X___,________,
    ___X_X__,________,
    __X___X_,________,
    ________,________,
    ___XXX__,________,
    __X___X_,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXXX,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
// 195 $c3 'Atilde'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XX___X,________,
    _X__XXX_,________,
    ________,________,
    ___XXX__,________,
    __X___X_,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXXX,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
// 196 $c4 'Adieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __X___X_,________,
    __X___X_,________,
    ________,________,
    ___XXX__,________,
    __X___X_,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXXX,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
// 197 $c5 'Aring'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ___XXX__,________,
    __X___X_,________,
    ___XXX__,________,
    ___X_X__,________,
    __X___X_,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXXX,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
// 198 $c6 'AE'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XX_XXX,________,
    _X__X___,________,
    _X__X___,________,
    _X__X___,________,
    _X__X___,________,
    _XXXXXX_,________,
    _X__X___,________,
    _X__X___,________,
    _X__X___,________,
    _X__XXXX,________,
    ________,________,
    ________,________,
    ________,________,
// 199 $c7 'Ccedilla'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X_____X,________,
    __XXXXX_,________,
    ____XX__,________,
    __X__X__,________,
    ___XX___,________,
// 200 $c8 'Egrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    __X_____,________,
    ___X____,________,
    ____X___,________,
    ________,________,
    _XXXXXXX,________,
    __X_____,________,
    __X_____,________,
    __XXXX__,________,
    __X_____,________,
    __X_____,________,
    __X_____,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
// 201 $c9 'Eacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ________,________,
    _XXXXXXX,________,
    __X_____,________,
    __X_____,________,
    __XXXX__,________,
    __X_____,________,
    __X_____,________,
    __X_____,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
// 202 $ca 'Ecircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ____X___,________,
    ___X_X__,________,
    __X___X_,________,
    ________,________,
    _XXXXXXX,________,
    __X_____,________,
    __X_____,________,
    __XXXX__,________,
    __X_____,________,
    __X_____,________,
    __X_____,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
// 203 $cb 'Edieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __X___X_,________,
    __X___X_,________,
    ________,________,
    _XXXXXXX,________,
    __X_____,________,
    __X_____,________,
    __XXXX__,________,
    __X_____,________,
    __X_____,________,
    __X_____,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
// 204 $cc 'Igrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    __X_____,________,
    ___X____,________,
    ____X___,________,
    ________,________,
    __XXXXX_,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 205 $cd 'Iacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ________,________,
    __XXXXX_,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 206 $ce 'Icircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ____X___,________,
    ___X_X__,________,
    __X___X_,________,
    ________,________,
    __XXXXX_,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 207 $cf 'Idieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __X___X_,________,
    __X___X_,________,
    ________,________,
    __XXXXX_,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 208 $d0 'Eth'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXX__,________,
    _X____X_,________,
    _X_____X,________,
    _X_____X,________,
    XXX____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X____X_,________,
    _XXXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 209 $d1 'Ntilde'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XX___X,________,
    _X__XXX_,________,
    ________,________,
    _X_____X,________,
    _XX____X,________,
    _X_X___X,________,
    _X__X__X,________,
    _X__X__X,________,
    _X___X_X,________,
    _X____XX,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
// 210 $d2 'Ograve'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    __X_____,________,
    ___X____,________,
    ____X___,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 211 $d3 'Oacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 212 $d4 'Ocircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ____X___,________,
    ___X_X__,________,
    __X___X_,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 213 $d5 'Otilde'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XX___X,________,
    _X__XXX_,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 214 $d6 'Odieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __X___X_,________,
    __X___X_,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 215 $d7 'multiply'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _X_____X,________,
    __X___X_,________,
    ___X_X__,________,
    ____X___,________,
    ___X_X__,________,
    __X___X_,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 216 $d8 'Oslash'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _______X,________,
    __XXXXX_,________,
    _X____XX,________,
    _X___X_X,________,
    _X___X_X,________,
    _X__X__X,________,
    _X__X__X,________,
    _X_X___X,________,
    _X_X___X,________,
    _XX____X,________,
    __XXXXX_,________,
    _X______,________,
    ________,________,
    ________,________,
// 217 $d9 'Ugrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    __X_____,________,
    ___X____,________,
    ____X___,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 218 $da 'Uacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 219 $db 'Ucircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ____X___,________,
    ___X_X__,________,
    __X___X_,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 220 $dc 'Udieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __X___X_,________,
    __X___X_,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 221 $dd 'Yacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ________,________,
    _X_____X,________,
    _X_____X,________,
    __X___X_,________,
    ___X_X__,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ________,________,
    ________,________,
    ________,________,
// 222 $de 'Thorn'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X______,________,
    _X______,________,
    _XXXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXX_,________,
    _X______,________,
    _X______,________,
    _X______,________,
    ________,________,
    ________,________,
    ________,________,
// 223 $df 'germandbls'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XXX__,________,
    __X___X_,________,
    __X___X_,________,
    __X__X__,________,
    _XX_X___,________,
    __X__X__,________,
    __X___X_,________,
    __X___X_,________,
    __X___X_,________,
    __X_XX__,________,
    ________,________,
    ________,________,
    ________,________,
// 224 $e0 'agrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ___X____,________,
    ____X___,________,
    _____X__,________,
    ________,________,
    __XXXXX_,________,
    _______X,________,
    _______X,________,
    __XXXXXX,________,
    _X_____X,________,
    _X____XX,________,
    __XXXX_X,________,
    ________,________,
    ________,________,
    ________,________,
// 225 $e1 'aacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ________,________,
    __XXXXX_,________,
    _______X,________,
    _______X,________,
    __XXXXXX,________,
    _X_____X,________,
    _X____XX,________,
    __XXXX_X,________,
    ________,________,
    ________,________,
    ________,________,
// 226 $e2 'acircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____X___,________,
    ___X_X__,________,
    __X___X_,________,
    ________,________,
    __XXXXX_,________,
    _______X,________,
    _______X,________,
    __XXXXXX,________,
    _X_____X,________,
    _X____XX,________,
    __XXXX_X,________,
    ________,________,
    ________,________,
    ________,________,
// 227 $e3 'atilde'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XX__X,________,
    __X__XX_,________,
    ________,________,
    __XXXXX_,________,
    _______X,________,
    _______X,________,
    __XXXXXX,________,
    _X_____X,________,
    _X____XX,________,
    __XXXX_X,________,
    ________,________,
    ________,________,
    ________,________,
// 228 $e4 'adieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __X___X_,________,
    __X___X_,________,
    ________,________,
    __XXXXX_,________,
    _______X,________,
    _______X,________,
    __XXXXXX,________,
    _X_____X,________,
    _X____XX,________,
    __XXXX_X,________,
    ________,________,
    ________,________,
    ________,________,
// 229 $e5 'aring'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____XX__,________,
    ___X__X_,________,
    ____XX__,________,
    ________,________,
    __XXXXX_,________,
    _______X,________,
    _______X,________,
    __XXXXXX,________,
    _X_____X,________,
    _X____XX,________,
    __XXXX_X,________,
    ________,________,
    ________,________,
    ________,________,
// 230 $e6 'ae'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XX_XX_,________,
    _X__X__X,________,
    ____X__X,________,
    __XXXXX_,________,
    _X__X___,________,
    _X__X__X,________,
    __XX_XXX,________,
    ________,________,
    ________,________,
    ________,________,
// 231 $e7 'ccedilla'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X_____X,________,
    __XXXXX_,________,
    ____XX__,________,
    __X__X__,________,
    ___XX___,________,
// 232 $e8 'egrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __X_____,________,
    ___X____,________,
    ____X___,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXXX,________,
    _X______,________,
    _X______,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 233 $e9 'eacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXXX,________,
    _X______,________,
    _X______,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 234 $ea 'ecircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____X___,________,
    ___X_X__,________,
    __X___X_,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXXX,________,
    _X______,________,
    _X______,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 235 $eb 'edieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __X___X_,________,
    __X___X_,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _XXXXXXX,________,
    _X______,________,
    _X______,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 236 $ec 'igrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __X_____,________,
    ___X____,________,
    ____X___,________,
    ________,________,
    __XXX___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 237 $ed 'iacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _____X__,________,
    ____X___,________,
    ___X____,________,
    ________,________,
    __XXX___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 238 $ee 'icircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ___X____,________,
    __X_X___,________,
    _X___X__,________,
    ________,________,
    __XXX___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 239 $ef 'idieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __X__X__,________,
    __X__X__,________,
    ________,________,
    __XXX___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    ____X___,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 240 $f0 'eth'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __X__X__,________,
    ___XX___,________,
    __X_X___,________,
    _____X__,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 241 $f1 'ntilde'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XX___X,________,
    _X__XXX_,________,
    ________,________,
    _X_XXXX_,________,
    _XX____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
// 242 $f2 'ograve'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __X_____,________,
    ___X____,________,
    ____X___,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 243 $f3 'oacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 244 $f4 'ocircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____X___,________,
    ___X_X__,________,
    __X___X_,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 245 $f5 'otilde'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XX___X,________,
    _X__XXX_,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 246 $f6 'odieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __X___X_,________,
    __X___X_,________,
    ________,________,
    __XXXXX_,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    _X_____X,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 247 $f7 'divide'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ____X___,________,
    ___XXX__,________,
    ____X___,________,
    ________,________,
    _XXXXXXX,________,
    ________,________,
    ____X___,________,
    ___XXX__,________,
    ____X___,________,
    ________,________,
    ________,________,
    ________,________,
// 248 $f8 'oslash'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _______X,________,
    __XXXXX_,________,
    _X___X_X,________,
    _X___X_X,________,
    _X__X__X,________,
    _X_X___X,________,
    _X_X___X,________,
    __XXXXX_,________,
    _X______,________,
    ________,________,
    ________,________,
// 249 $f9 'ugrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __X_____,________,
    ___X____,________,
    ____X___,________,
    ________,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    __XXXX_X,________,
    ________,________,
    ________,________,
    ________,________,
// 250 $fa 'uacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ______X_,________,
    _____X__,________,
    ____X___,________,
    ________,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    __XXXX_X,________,
    ________,________,
    ________,________,
    ________,________,
// 251 $fb 'ucircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____X___,________,
    ___X_X__,________,
    __X___X_,________,
    ________,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    __XXXX_X,________,
    ________,________,
    ________,________,
    ________,________,
// 252 $fc 'udieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __X__X__,________,
    __X__X__,________,
    ________,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    __XXXX_X,________,
    ________,________,
    ________,________,
    ________,________,
// 253 $fd 'yacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _____X__,________,
    ____X___,________,
    ___X____,________,
    ________,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X___XX_,________,
    __XXX_X_,________,
    ______X_,________,
    _X____X_,________,
    __XXXX__,________,
// 254 $fe 'thorn'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    _X______,________,
    _X______,________,
    _X______,________,
    _X_XXXX_,________,
    _XX____X,________,
    _X_____X,________,
    _X_____X,________,
    _XX____X,________,
    _X_XXXX_,________,
    _X______,________,
    _X______,________,
    _X______,________,
// 255 $ff 'ydieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __X__X__,________,
    __X__X__,________,
    ________,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X____X_,________,
    _X___XX_,________,
    __XXX_X_,________,
    ______X_,________,
    _X____X_,________,
    __XXXX__,________
};

static const unsigned char font_9x15B[] = {
//  32 $20 'space'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  33 $21 'exclam'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ________,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ________,________,
//  34 $22 'quotedbl'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XX_XX_,________,
    __XX_XX_,________,
    __XX_XX_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  35 $23 'numbersign'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    __XX_XX_,________,
    __XX_XX_,________,
    _XXXXXXX,________,
    __XX_XX_,________,
    __XX_XX_,________,
    _XXXXXXX,________,
    __XX_XX_,________,
    __XX_XX_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  36 $24 'dollar'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____X___,________,
    __XXXXX_,________,
    _XX_X_XX,________,
    _XX_X___,________,
    _XXXX___,________,
    __XXXXX_,________,
    ____XXXX,________,
    ____X_XX,________,
    _XX_X_XX,________,
    __XXXXX_,________,
    ____X___,________,
    ________,________,
    ________,________,
//  37 $25 'percent'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _X____XX,________,
    XXX__XX_,________,
    XXX__XX_,________,
    _X__XX__,________,
    ___XX___,________,
    ___XX___,________,
    __XX__X_,________,
    _XX__XXX,________,
    _XX__XXX,________,
    XX____X_,________,
    ________,________,
    ________,________,
    ________,________,
//  38 $26 'ampersand'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXX___,________,
    _XX_XX__,________,
    _XX_XX__,________,
    _XXXX___,________,
    __XX____,________,
    _XXXX__X,________,
    XX__XXXX,________,
    XX___XX_,________,
    XX__XXX_,________,
    _XXXX_XX,________,
    ________,________,
    ________,________,
    ________,________,
//  39 $27 'quotesingle'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  40 $28 'parenleft'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _____XX_,________,
    ____XX__,________,
    ___XX___,________,
    ___XX___,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    ___XX___,________,
    ___XX___,________,
    ____XX__,________,
    _____XX_,________,
    ________,________,
    ________,________,
//  41 $29 'parenright'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XX____,________,
    ___XX___,________,
    ____XX__,________,
    ____XX__,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    ____XX__,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    ________,________,
    ________,________,
//  42 $2a 'asterisk'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XX_XX_,________,
    ___XXX__,________,
    _XXXXXXX,________,
    ___XXX__,________,
    __XX_XX_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  43 $2b 'plus'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    XXXXXXXX,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  44 $2c 'comma'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ___XXX__,________,
    ___XXX__,________,
    ____XX__,________,
    ____XX__,________,
    ___XX___,________,
//  45 $2d 'hyphen'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    XXXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  46 $2e 'period'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ___XX___,________,
    __XXXX__,________,
    ___XX___,________,
    ________,________,
    ________,________,
//  47 $2f 'slash'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ______XX,________,
    _____XX_,________,
    _____XX_,________,
    ____XX__,________,
    ___XX___,________,
    ___XX___,________,
    __XX____,________,
    _XX_____,________,
    _XX_____,________,
    XX______,________,
    ________,________,
    ________,________,
    ________,________,
//  48 $30 'zero'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ________,________,
//  49 $31 'one'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XX___,________,
    __XXX___,________,
    _XXXX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  50 $32 'two'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    ______XX,________,
    _____XX_,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    _XX_____,________,
    XXXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
//  51 $33 'three'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXX__,________,
    XX___XX_,________,
    ______XX,________,
    _____XX_,________,
    ___XXX__,________,
    _____XX_,________,
    ______XX,________,
    ______XX,________,
    XX___XX_,________,
    _XXXXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  52 $34 'four'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _____XX_,________,
    ____XXX_,________,
    ___XXXX_,________,
    __XX_XX_,________,
    _XX__XX_,________,
    XX___XX_,________,
    XXXXXXXX,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    ________,________,
    ________,________,
    ________,________,
//  53 $35 'five'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XXXXXXX_,________,
    XX______,________,
    XX______,________,
    XX_XXX__,________,
    XXX__XX_,________,
    ______XX,________,
    ______XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  54 $36 'six'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____X_,________,
    XX______,________,
    XX_XXX__,________,
    XXX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  55 $37 'seven'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XXXXXXXX,________,
    ______XX,________,
    ______XX,________,
    _____XX_,________,
    ____XX__,________,
    ____XX__,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ________,________,
//  56 $38 'eight'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  57 $39 'nine'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XXX,________,
    __XXX_XX,________,
    ______XX,________,
    _X____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  58 $3a 'colon'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ___XX___,________,
    __XXXX__,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ___XX___,________,
    __XXXX__,________,
    ___XX___,________,
    ________,________,
    ________,________,
//  59 $3b 'semicolon'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ___XX___,________,
    __XXXX__,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ___XXX__,________,
    ___XXX__,________,
    ____XX__,________,
    ____XX__,________,
    ___XX___,________,
//  60 $3c 'less'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _____XX_,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    _XX_____,________,
    _XX_____,________,
    __XX____,________,
    ___XX___,________,
    ____XX__,________,
    _____XX_,________,
    ________,________,
    ________,________,
    ________,________,
//  61 $3d 'equal'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    XXXXXXXX,________,
    ________,________,
    ________,________,
    XXXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  62 $3e 'greater'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XX_____,________,
    __XX____,________,
    ___XX___,________,
    ____XX__,________,
    _____XX_,________,
    _____XX_,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    _XX_____,________,
    ________,________,
    ________,________,
    ________,________,
//  63 $3f 'question'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    _XX___XX,________,
    _XX___XX,________,
    ______XX,________,
    _____XX_,________,
    ____XX__,________,
    ___XX___,________,
    ________,________,
    ___XX___,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ________,________,
//  64 $40 'at'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX__XXXX,________,
    XX_XX_XX,________,
    XX_XX_XX,________,
    XX__XXX_,________,
    XX______,________,
    _XX___XX,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  65 $41 'A'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XXXXXXXX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
//  66 $42 'B'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XXXXXX__,________,
    XX___XX_,________,
    XX____XX,________,
    XX___XX_,________,
    XXXXXX__,________,
    XX___XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX___XX_,________,
    XXXXXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  67 $43 'C'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    _XX___XX,________,
    XX_____X,________,
    XX______,________,
    XX______,________,
    XX______,________,
    XX______,________,
    XX_____X,________,
    _XX___XX,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  68 $44 'D'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XXXXXX__,________,
    XX___XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX___XX_,________,
    XXXXXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  69 $45 'E'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXXX,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XXXXXX_,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
//  70 $46 'F'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XXXXXXXX,________,
    XX______,________,
    XX______,________,
    XX______,________,
    XXXXXX__,________,
    XX______,________,
    XX______,________,
    XX______,________,
    XX______,________,
    XX______,________,
    ________,________,
    ________,________,
    ________,________,
//  71 $47 'G'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    _XX___XX,________,
    XX______,________,
    XX______,________,
    XX______,________,
    XX___XXX,________,
    XX____XX,________,
    XX____XX,________,
    _XX___XX,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  72 $48 'H'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XXXXXXXX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
//  73 $49 'I'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXX_,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  74 $4a 'J'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XXXX_,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    _X___XX_,________,
    _XX_XX__,________,
    __XXX___,________,
    ________,________,
    ________,________,
    ________,________,
//  75 $4b 'K'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XX____XX,________,
    XX___XX_,________,
    XX__XX__,________,
    XX_XX___,________,
    XXXX____,________,
    XXXX____,________,
    XX_XX___,________,
    XX__XX__,________,
    XX___XX_,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
//  76 $4c 'L'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
//  77 $4d 'M'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XX____XX,________,
    XXX__XXX,________,
    XXXXXXXX,________,
    XX_XX_XX,________,
    XX_XX_XX,________,
    XX_XX_XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
//  78 $4e 'N'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XX____XX,________,
    XXX___XX,________,
    XXXX__XX,________,
    XXXX__XX,________,
    XX_XX_XX,________,
    XX_XX_XX,________,
    XX__XXXX,________,
    XX___XXX,________,
    XX___XXX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
//  79 $4f 'O'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  80 $50 'P'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XXXXXXX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XXXXXXX_,________,
    XX______,________,
    XX______,________,
    XX______,________,
    XX______,________,
    XX______,________,
    ________,________,
    ________,________,
    ________,________,
//  81 $51 'Q'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX_XX_XX,________,
    XX__XXXX,________,
    _XX__XX_,________,
    __XXXX_X,________,
    ________,________,
    ________,________,
    ________,________,
//  82 $52 'R'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XXXXXXX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XXXXXXX_,________,
    XXXXX___,________,
    XX__XX__,________,
    XX___XX_,________,
    XX____XX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
//  83 $53 'S'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXX_,________,
    XX____XX,________,
    XX______,________,
    XX______,________,
    _XXXXXX_,________,
    ______XX,________,
    ______XX,________,
    ______XX,________,
    XX____XX,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
//  84 $54 'T'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XXXXXXXX,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ________,________,
//  85 $55 'U'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  86 $56 'V'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    _XX__XX_,________,
    _XX__XX_,________,
    __XXXX__,________,
    __XXXX__,________,
    ___XX___,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ________,________,
//  87 $57 'W'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX_XX_XX,________,
    XX_XX_XX,________,
    XX_XX_XX,________,
    XXXXXXXX,________,
    XXX__XXX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
//  88 $58 'X'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ___XX___,________,
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
//  89 $59 'Y'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ________,________,
//  90 $5a 'Z'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXXX,________,
    ______XX,________,
    ______XX,________,
    _____XX_,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    _XX_____,________,
    _XX_____,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
//  91 $5b 'bracketleft'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XXXXX_,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
//  92 $5c 'backslash'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XX______,________,
    _XX_____,________,
    _XX_____,________,
    __XX____,________,
    ___XX___,________,
    ___XX___,________,
    ____XX__,________,
    _____XX_,________,
    _____XX_,________,
    ______XX,________,
    ________,________,
    ________,________,
    ________,________,
//  93 $5d 'bracketright'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XXXXX_,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    _____XX_,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
//  94 $5e 'asciicircum'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    _X____X_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  95 $5f 'underscore'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    XXXXXXXX,________,
    ________,________,
    ________,________,
//  96 $60 'grave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XX____,________,
    ___XX___,________,
    ____XX__,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
//  97 $61 'a'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXXXX_,________,
    _XX___XX,________,
    ______XX,________,
    _XXXXXXX,________,
    XX____XX,________,
    XX___XXX,________,
    _XXXX_XX,________,
    ________,________,
    ________,________,
    ________,________,
//  98 $62 'b'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XX______,________,
    XX______,________,
    XX______,________,
    XX_XXX__,________,
    XXX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XXX__XX_,________,
    XX_XXX__,________,
    ________,________,
    ________,________,
    ________,________,
//  99 $63 'c'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXXXX_,________,
    _XX___XX,________,
    XX______,________,
    XX______,________,
    XX______,________,
    _XX___XX,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 100 $64 'd'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ______XX,________,
    ______XX,________,
    ______XX,________,
    __XXX_XX,________,
    _XX__XXX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XXX,________,
    __XXX_XX,________,
    ________,________,
    ________,________,
    ________,________,
// 101 $65 'e'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XXXXXXXX,________,
    XX______,________,
    _XX___XX,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 102 $66 'f'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XXXX_,________,
    __XX__XX,________,
    __XX__XX,________,
    __XX____,________,
    __XX____,________,
    XXXXXX__,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    ________,________,
    ________,________,
    ________,________,
// 103 $67 'g'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _XXXXX_X,________,
    XX___XXX,________,
    XX___XX_,________,
    XX___XX_,________,
    _XXXXX__,________,
    XX______,________,
    _XXXXXX_,________,
    XX____XX,________,
    XX____XX,________,
    _XXXXXX_,________,
// 104 $68 'h'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XX______,________,
    XX______,________,
    XX______,________,
    XX_XXX__,________,
    XXX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
// 105 $69 'i'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XX___,________,
    ___XX___,________,
    ________,________,
    __XXX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 106 $6a 'j'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ______XX,________,
    ______XX,________,
    ________,________,
    ____XXXX,________,
    ______XX,________,
    ______XX,________,
    ______XX,________,
    ______XX,________,
    ______XX,________,
    _XX___XX,________,
    _XX___XX,________,
    _XX___XX,________,
    __XXXXX_,________,
// 107 $6b 'k'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XX__XX_,________,
    _XX_XX__,________,
    _XXXX___,________,
    _XXXX___,________,
    _XX_XX__,________,
    _XX__XX_,________,
    _XX___XX,________,
    ________,________,
    ________,________,
    ________,________,
// 108 $6c 'l'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 109 $6d 'm'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    X_XX_XX_,________,
    XX_XX_XX,________,
    XX_XX_XX,________,
    XX_XX_XX,________,
    XX_XX_XX,________,
    XX_XX_XX,________,
    XX_XX_XX,________,
    ________,________,
    ________,________,
    ________,________,
// 110 $6e 'n'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    XX_XXX__,________,
    XXX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
// 111 $6f 'o'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 112 $70 'p'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    XX_XXX__,________,
    XXX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XXX__XX_,________,
    XX_XXX__,________,
    XX______,________,
    XX______,________,
    XX______,________,
// 113 $71 'q'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXX_XX,________,
    _XX__XXX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XXX,________,
    __XXX_XX,________,
    ______XX,________,
    ______XX,________,
    ______XX,________,
// 114 $72 'r'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    XX_XXXX_,________,
    _XXX__XX,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    ________,________,
    ________,________,
    ________,________,
// 115 $73 's'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _XXXXXX_,________,
    XX____XX,________,
    XX______,________,
    _XXXXXX_,________,
    ______XX,________,
    XX____XX,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 116 $74 't'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    __XX____,________,
    __XX____,________,
    XXXXXX__,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    __XX__XX,________,
    ___XXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 117 $75 'u'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XXX,________,
    __XXX_XX,________,
    ________,________,
    ________,________,
    ________,________,
// 118 $76 'v'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    _XX__XX_,________,
    __XXXX__,________,
    __XXXX__,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ________,________,
// 119 $77 'w'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX_XX_XX,________,
    XX_XX_XX,________,
    XX_XX_XX,________,
    XXXXXXXX,________,
    _XX__XX_,________,
    ________,________,
    ________,________,
    ________,________,
// 120 $78 'x'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
// 121 $79 'y'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XXX,________,
    __XXX_XX,________,
    ______XX,________,
    XX___XX_,________,
    _XXXXX__,________,
// 122 $7a 'z'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _XXXXXX_,________,
    _____XX_,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    _XX_____,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 123 $7b 'braceleft'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____XXX_,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    __XX____,________,
    __XX____,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ____XXX_,________,
    ________,________,
    ________,________,
// 124 $7c 'bar'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ________,________,
// 125 $7d 'braceright'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XXX___,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    _____XX_,________,
    _____XX_,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    __XXX___,________,
    ________,________,
    ________,________,
// 126 $7e 'asciitilde'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXX__XX,________,
    XX_XX_XX,________,
    XX__XXX_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 160 $a0 'space'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 161 $a1 'exclamdown'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____XX__,________,
    ________,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    ________,________,
    ________,________,
    ________,________,
// 162 $a2 'cent'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ______X_,________,
    __XXXXX_,________,
    _XX__XXX,________,
    _XX_X___,________,
    _XX_X___,________,
    _XXX__XX,________,
    __XXXXX_,________,
    __X_____,________,
    ________,________,
    ________,________,
    ________,________,
// 163 $a3 'sterling'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ___XXXX_,________,
    __XX__XX,________,
    __XX____,________,
    __XX____,________,
    _XXXXX__,________,
    __XX____,________,
    __XX____,________,
    XXXXX___,________,
    X_XXXXXX,________,
    XXX_____,________,
    ________,________,
    ________,________,
// 164 $a4 'currency'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    _XX___XX,________,
    _XXXXXXX,________,
    __XX_XX_,________,
    __X___X_,________,
    __XX_XX_,________,
    _XXXXXXX,________,
    _XX___XX,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 165 $a5 'yen'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    _XXXXXX_,________,
    ___XX___,________,
    _XXXXXX_,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ________,________,
// 166 $a6 'brokenbar'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    ________,________,
    ________,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    ____XX__,________,
    ________,________,
    ________,________,
// 167 $a7 'section'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    _XX_____,________,
    __XXXX__,________,
    _XX__XX_,________,
    _XX__XX_,________,
    _XX__XX_,________,
    __XXXX__,________,
    _____XX_,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
// 168 $a8 'dieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XX__XX_,________,
    _XX__XX_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 169 $a9 'copyright'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XXXX__,________,
    _XXXXXX_,________,
    XX____XX,________,
    X_XXXX_X,________,
    X_X__X_X,________,
    X_X____X,________,
    X_X__X_X,________,
    X_XXXX_X,________,
    XX____XX,________,
    _XXXXXX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 170 $aa 'ordfeminine'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXX___,________,
    ____XX__,________,
    _XXXXX__,________,
    _X__XX__,________,
    _XXXXX__,________,
    ________,________,
    _XXXXX__,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 171 $ab 'guillemotleft'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ___XX_XX,________,
    __XX_XX_,________,
    _XX_XX__,________,
    XX_XX___,________,
    XX_XX___,________,
    _XX_XX__,________,
    __XX_XX_,________,
    ___XX_XX,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 172 $ac 'logicalnot'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _XXXXXXX,________,
    _XXXXXXX,________,
    ______XX,________,
    ______XX,________,
    ______XX,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 173 $ad 'hyphen'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 174 $ae 'registered'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XXXX__,________,
    _XXXXXX_,________,
    XX____XX,________,
    X_XXXX_X,________,
    X_X__X_X,________,
    X_XXXX_X,________,
    X_X_X__X,________,
    X_X_XX_X,________,
    XX____XX,________,
    _XXXXXX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 175 $af 'macron'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XXXXXX_,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 176 $b0 'degree'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XXXX_,________,
    __XX__XX,________,
    __XX__XX,________,
    ___XXXX_,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 177 $b1 'plusminus'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    XXXXXXXX,________,
    XXXXXXXX,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    XXXXXXXX,________,
    XXXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
// 178 $b2 'twosuperior'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XXX___,________,
    _X__XX__,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    _XX_____,________,
    _XXXXX__,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 179 $b3 'threesuperior'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XXX___,________,
    _X__XX__,________,
    ____XX__,________,
    ___XX___,________,
    ____XX__,________,
    _X__XX__,________,
    __XXX___,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 180 $b4 'acute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 181 $b5 'mu'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _XX___XX,________,
    _XX___XX,________,
    _XX___XX,________,
    _XX___XX,________,
    _XX___XX,________,
    _XXX_XXX,________,
    _XXXXX_X,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
// 182 $b6 'paragraph'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXXX,________,
    _XXXXXXX,________,
    _XXXX_XX,________,
    _XXXX_XX,________,
    _XXXX_XX,________,
    __XXX_XX,________,
    ___XX_XX,________,
    ___XX_XX,________,
    ___XX_XX,________,
    ___XX_XX,________,
    ________,________,
    ________,________,
    ________,________,
// 183 $b7 'periodcentered'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ____X___,________,
    ___XXX__,________,
    ____X___,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 184 $b8 'cedilla'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _____XX_,________,
    __XX_XX_,________,
    ___XXX__,________,
// 185 $b9 'onesuperior'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XX____,________,
    _XXX____,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    __XX____,________,
    _XXXX___,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 186 $ba 'ordmasculine'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXX___,________,
    _XX_XX__,________,
    _XX_XX__,________,
    __XXX___,________,
    ________,________,
    _XXXXX__,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 187 $bb 'guillemotright'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    XX_XX___,________,
    _XX_XX__,________,
    __XX_XX_,________,
    ___XX_XX,________,
    ___XX_XX,________,
    __XX_XX_,________,
    _XX_XX__,________,
    XX_XX___,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
// 188 $bc 'onequarter'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XX_____,________,
    XXX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XX____X,________,
    _XX___XX,________,
    XXXX_XXX,________,
    ____XXXX,________,
    ___XX_XX,________,
    ___XXXXX,________,
    ______XX,________,
    ________,________,
    ________,________,
    ________,________,
// 189 $bd 'onehalf'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XX_____,________,
    XXX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XX_XXX_,________,
    _XXX__XX,________,
    XXXX__XX,________,
    _____XX_,________,
    ____XX__,________,
    ___XX___,________,
    ___XXXXX,________,
    ________,________,
    ________,________,
    ________,________,
// 190 $be 'threequarters'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XXX____,________,
    X__XX___,________,
    ___XX___,________,
    __XX____,________,
    ___XX__X,________,
    X__XX_XX,________,
    _XXX_XXX,________,
    ____XXXX,________,
    ___XX_XX,________,
    ___XXXXX,________,
    ______XX,________,
    ________,________,
    ________,________,
    ________,________,
// 191 $bf 'questiondown'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ____XX__,________,
    ____XX__,________,
    ________,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    _XX_____,________,
    _XX___XX,________,
    _XX___XX,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 192 $c0 'Agrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    _XX_____,________,
    __XX____,________,
    ___XX___,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XXXXXXXX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
// 193 $c1 'Aacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    _____XX_,________,
    ____XX__,________,
    ___XX___,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XXXXXXXX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
// 194 $c2 'Acircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XXXXXXXX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
// 195 $c3 'Atilde'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    __XX__X_,________,
    _XXXXXX_,________,
    _X__XX__,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XXXXXXXX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
// 196 $c4 'Adieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XX__XX_,________,
    _XX__XX_,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XXXXXXXX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
// 197 $c5 'Aring'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ___XX___,________,
    __X__X__,________,
    __X__X__,________,
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XXXXXXXX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
// 198 $c6 'AE'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XXXXX,________,
    __XXXX__,________,
    _XX_XX__,________,
    _XX_XX__,________,
    XX__XX__,________,
    XXXXXXXX,________,
    XX__XX__,________,
    XX__XX__,________,
    XX__XX__,________,
    XX__XXXX,________,
    ________,________,
    ________,________,
    ________,________,
// 199 $c7 'Ccedilla'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    __XXXXX_,________,
    _XX___XX,________,
    XX_____X,________,
    XX______,________,
    XX______,________,
    XX______,________,
    XX______,________,
    XX_____X,________,
    _XX___XX,________,
    __XXXXX_,________,
    ____XX__,________,
    _XX_XX__,________,
    __XXX___,________,
// 200 $c8 'Egrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    __XX____,________,
    ___XX___,________,
    ____XX__,________,
    ________,________,
    _XXXXXXX,________,
    _XX_____,________,
    _XX_____,________,
    _XXXXXX_,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
// 201 $c9 'Eacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    _____XX_,________,
    ____XX__,________,
    ___XX___,________,
    ________,________,
    _XXXXXXX,________,
    _XX_____,________,
    _XX_____,________,
    _XXXXXX_,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
// 202 $ca 'Ecircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ____XX__,________,
    ___XXXX_,________,
    __XX__XX,________,
    ________,________,
    _XXXXXXX,________,
    _XX_____,________,
    _XX_____,________,
    _XXXXXX_,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
// 203 $cb 'Edieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XX__XX,________,
    __XX__XX,________,
    ________,________,
    _XXXXXXX,________,
    _XX_____,________,
    _XX_____,________,
    _XXXXXX_,________,
    _XX_____,________,
    _XX_____,________,
    _XX_____,________,
    _XXXXXXX,________,
    ________,________,
    ________,________,
    ________,________,
// 204 $cc 'Igrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    _XX_____,________,
    __XX____,________,
    ___XX___,________,
    ________,________,
    _XXXXXX_,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 205 $cd 'Iacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    ________,________,
    _XXXXXX_,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 206 $ce 'Icircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    ________,________,
    _XXXXXX_,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 207 $cf 'Idieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XX__XX_,________,
    _XX__XX_,________,
    ________,________,
    _XXXXXX_,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 208 $d0 'Eth'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXXXX_,________,
    _XX___XX,________,
    _XX____X,X_______,
    _XX____X,X_______,
    XXXXX__X,X_______,
    XXXXX__X,X_______,
    _XX____X,X_______,
    _XX____X,X_______,
    _XX___XX,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 209 $d1 'Ntilde'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    __XX__X_,________,
    _XXXXXX_,________,
    _X__XX__,________,
    ________,________,
    XX____XX,________,
    XXX___XX,________,
    XXXX__XX,________,
    XXXXX_XX,________,
    XX_XXXXX,________,
    XX__XXXX,________,
    XX___XXX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
// 210 $d2 'Ograve'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    _XX_____,________,
    __XX____,________,
    ___XX___,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 211 $d3 'Oacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    _____XX_,________,
    ____XX__,________,
    ___XX___,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 212 $d4 'Ocircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 213 $d5 'Otilde'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    __XX__X_,________,
    _XXXXXX_,________,
    _X__XX__,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 214 $d6 'Odieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XX__XX_,________,
    _XX__XX_,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 215 $d7 'multiply'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _X_____X,________,
    _XX___XX,________,
    __XX_XX_,________,
    ___XXX__,________,
    ___XXX__,________,
    __XX_XX_,________,
    _XX___XX,________,
    _X_____X,________,
    ________,________,
    ________,________,
    ________,________,
// 216 $d8 'Oslash'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _______X,________,
    __XXXXXX,________,
    _XX__XX_,________,
    XX___XXX,________,
    XX__X_XX,________,
    XX__X_XX,________,
    XX_X__XX,________,
    XX_X__XX,________,
    XXX___XX,________,
    _XX__XX_,________,
    XXXXXX__,________,
    X_______,________,
    ________,________,
    ________,________,
// 217 $d9 'Ugrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    _XX_____,________,
    __XX____,________,
    ___XX___,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 218 $da 'Uacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    _____XX_,________,
    ____XX__,________,
    ___XX___,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 219 $db 'Ucircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 220 $dc 'Udieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XX__XX_,________,
    _XX__XX_,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 221 $dd 'Yacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    _____XX_,________,
    ____XX__,________,
    ___XX___,________,
    ________,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ________,________,
// 222 $de 'Thorn'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XXXX___,________,
    __XX____,________,
    __XXXXX_,________,
    __XX__XX,________,
    __XX__XX,________,
    __XX__XX,________,
    __XXXXX_,________,
    __XX____,________,
    __XX____,________,
    _XXXX___,________,
    ________,________,
    ________,________,
    ________,________,
// 223 $df 'germandbls'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XXXX_,________,
    __XX__XX,________,
    _XX___XX,________,
    _XX__XX_,________,
    _XX_XX__,________,
    _XX__XX_,________,
    _XX___XX,________,
    _XX___XX,________,
    _XX___XX,________,
    _XX_XXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 224 $e0 'agrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XX_____,________,
    __XX____,________,
    ___XX___,________,
    ________,________,
    __XXXXX_,________,
    _X____XX,________,
    ______XX,________,
    _XXXXXXX,________,
    XX____XX,________,
    XX___XXX,________,
    _XXXX_XX,________,
    ________,________,
    ________,________,
    ________,________,
// 225 $e1 'aacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    ________,________,
    __XXXXX_,________,
    _X____XX,________,
    ______XX,________,
    _XXXXXXX,________,
    XX____XX,________,
    XX___XXX,________,
    _XXXX_XX,________,
    ________,________,
    ________,________,
    ________,________,
// 226 $e2 'acircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    ________,________,
    __XXXXX_,________,
    _X____XX,________,
    ______XX,________,
    _XXXXXXX,________,
    XX____XX,________,
    XX___XXX,________,
    _XXXX_XX,________,
    ________,________,
    ________,________,
    ________,________,
// 227 $e3 'atilde'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XX__X_,________,
    _XXXXXX_,________,
    _X__XX__,________,
    ________,________,
    __XXXXX_,________,
    _X____XX,________,
    ______XX,________,
    _XXXXXXX,________,
    XX____XX,________,
    XX___XXX,________,
    _XXXX_XX,________,
    ________,________,
    ________,________,
    ________,________,
// 228 $e4 'adieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XX__XX_,________,
    _XX__XX_,________,
    ________,________,
    __XXXXX_,________,
    _X____XX,________,
    ______XX,________,
    _XXXXXXX,________,
    XX____XX,________,
    XX___XXX,________,
    _XXXX_XX,________,
    ________,________,
    ________,________,
    ________,________,
// 229 $e5 'aring'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ___XX___,________,
    __X__X__,________,
    __X__X__,________,
    ___XX___,________,
    __XXXXX_,________,
    _X____XX,________,
    ______XX,________,
    _XXXXXXX,________,
    XX____XX,________,
    XX___XXX,________,
    _XXXX_XX,________,
    ________,________,
    ________,________,
    ________,________,
// 230 $e6 'ae'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _XXX_XX_,________,
    X__XX_XX,________,
    ___XX_XX,________,
    _XXXXXX_,________,
    XX_XX___,________,
    XX_XX__X,________,
    _XX_XXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 231 $e7 'ccedilla'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    __XXXXX_,________,
    _XX___XX,________,
    XX______,________,
    XX______,________,
    XX______,________,
    _XX___XX,________,
    __XXXXX_,________,
    ____XX__,________,
    _XX_XX__,________,
    __XXX___,________,
// 232 $e8 'egrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XX_____,________,
    __XX____,________,
    ___XX___,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XXXXXXXX,________,
    XX______,________,
    _XX___XX,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 233 $e9 'eacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XXXXXXXX,________,
    XX______,________,
    _XX___XX,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 234 $ea 'ecircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XXXXXXXX,________,
    XX______,________,
    _XX___XX,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 235 $eb 'edieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XX__XX_,________,
    _XX__XX_,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XXXXXXXX,________,
    XX______,________,
    _XX___XX,________,
    __XXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 236 $ec 'igrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XX_____,________,
    __XX____,________,
    ___XX___,________,
    ________,________,
    __XXX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 237 $ed 'iacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    ________,________,
    __XXX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 238 $ee 'icircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    ________,________,
    __XXX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 239 $ef 'idieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XX__XX_,________,
    _XX__XX_,________,
    ________,________,
    __XXX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    ___XX___,________,
    _XXXXXX_,________,
    ________,________,
    ________,________,
    ________,________,
// 240 $f0 'eth'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    X___X___,________,
    XX_XX___,________,
    _XXX____,________,
    _XXX____,________,
    XX_XX___,________,
    X___XX__,________,
    __XXXXX_,________,
    _XX__XXX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 241 $f1 'ntilde'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XX__X_,________,
    _XXXXXX_,________,
    _X__XX__,________,
    ________,________,
    XX_XXX__,________,
    XXX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    ________,________,
    ________,________,
    ________,________,
// 242 $f2 'ograve'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XX_____,________,
    __XX____,________,
    ___XX___,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 243 $f3 'oacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 244 $f4 'ocircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 245 $f5 'otilde'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    __XX__X_,________,
    _XXXXXX_,________,
    _X__XX__,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 246 $f6 'odieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XX__XX_,________,
    _XX__XX_,________,
    ________,________,
    __XXXX__,________,
    _XX__XX_,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XX_,________,
    __XXXX__,________,
    ________,________,
    ________,________,
    ________,________,
// 247 $f7 'divide'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ___XX___,________,
    ___XX___,________,
    ________,________,
    ________,________,
    XXXXXXXX,________,
    XXXXXXXX,________,
    ________,________,
    ________,________,
    ___XX___,________,
    ___XX___,________,
    ________,________,
    ________,________,
    ________,________,
// 248 $f8 'oslash'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    ________,________,
    _______X,________,
    __XXXXXX,________,
    _XX__XX_,________,
    XX__XXXX,________,
    XX_XX_XX,________,
    XXXX__XX,________,
    _XX__XX_,________,
    XXXXXX__,________,
    X_______,________,
    ________,________,
    ________,________,
// 249 $f9 'ugrave'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    _XX_____,________,
    __XX____,________,
    ___XX___,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XXX,________,
    __XXX_XX,________,
    ________,________,
    ________,________,
    ________,________,
// 250 $fa 'uacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XXX,________,
    __XXX_XX,________,
    ________,________,
    ________,________,
    ________,________,
// 251 $fb 'ucircumflex'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ___XX___,________,
    __XXXX__,________,
    _XX__XX_,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XXX,________,
    __XXX_XX,________,
    ________,________,
    ________,________,
    ________,________,
// 252 $fc 'udieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XX__XX_,________,
    _XX__XX_,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XXX,________,
    __XXX_XX,________,
    ________,________,
    ________,________,
    ________,________,
// 253 $fd 'yacute'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ____XX__,________,
    ___XX___,________,
    __XX____,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XXX,________,
    __XXX_XX,________,
    ______XX,________,
    XX___XX_,________,
    _XXXXX__,________,
// 254 $fe 'thorn'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    ________,________,
    _XXX____,________,
    __XX____,________,
    __XX____,________,
    __XXXXX_,________,
    __XX__XX,________,
    __XX__XX,________,
    __XX__XX,________,
    __XX__XX,________,
    __XXXXX_,________,
    __XX____,________,
    __XX____,________,
    _XXX____,________,
// 255 $ff 'ydieresis'
//    width 9, bbx 0, bby -3, bbw 9, bbh 15
    ________,________,
    ________,________,
    _XX__XX_,________,
    _XX__XX_,________,
    ________,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    XX____XX,________,
    _XX__XXX,________,
    __XXX_XX,________,
    ______XX,________,
    XX___XX_,________,
    _XXXXX__,________
};

NDPluginOverlayTextFontBitmapType __6x13  = { 6, 13, font_6x13};
NDPluginOverlayTextFontBitmapType __6x13B = { 6, 13, font_6x13B};
NDPluginOverlayTextFontBitmapType __9x15  = { 9, 15, font_9x15};
NDPluginOverlayTextFontBitmapType __9x15B = { 9, 15, font_9x15B};

NDPluginOverlayTextFontBitmapType NDPluginOverlayTextFontBitmaps[] = {
  __6x13,
  __6x13B,
  __9x15,
  __9x15B
};

const int NDPluginOverlayTextFontBitmapTypeN = 4;
